owner ID
start date
end date

select 
   ssblock.ss_block_id, ssblock.date_created, ssblock.date_updated, 
   ssblock.deleted, ssblock.owner_user_pk1, ssblock.ss_framework_id, 
   ssblock.ss_block_set_id, ssblock.start_datetime, ssblock.end_datetime, 
   ssblock.max_slots, 
   count(ssslot.ss_slot_id) as block_usage
from wms_ss_block ssblock, wms_ss_slot ssslot
where ssblock.deleted='N'
and ssblock.owner_user_pk1 = 2339
and ssslot.ss_block_id = ssblock.ss_block_id
and ssblock.start_datetime >= sysdate
and ssblock.end_datetime <= sysdate + 6
group by
   ssblock.ss_block_id, ssblock.date_created, ssblock.date_updated, 
   ssblock.deleted, ssblock.owner_user_pk1, ssblock.ss_framework_id, 
   ssblock.ss_block_set_id, ssblock.start_datetime, ssblock.end_datetime, 
   ssblock.max_slots
order by ssblock.start_datetime


select *
from  course_main
where course_name like '%CSW%' 

select sysdate from dual

-- 2339 - Chris' PK 
-- 5418 - Comb's PK 
-- 3393 - Jnathan's PK 

-- 35 - Mika's test course PK 
-- 4024 - Chris' test course PK 


select ssblock.ss_block_id, ssblock.date_created, ssblock.date_updated, ssblock.deleted, ssblock.owner_user_pk1, ssblock.ss_framework_id, ssblock.ss_block_set_id, ssblock.start_datetime, ssblock.end_datetime, ssblock.max_slots, count(ssslot.ss_slot_id) as block_usage
FROM wms_ss_block ssblock, wms_ss_slot ssslot, wms_ss_framework ssframework, wms_ss_access ssaccess
WHERE  ssblock.deleted='N'
AND ssblock.ss_block_id = ssslot.ss_block_id
AND ssframework.ss_framework_id = ssblock.ss_framework_id
AND ssaccess.ss_framework_id = ssframework.ss_framework_id
AND ssaccess.access_category = 'COURSE'
AND ssaccess.allowed_pk1 = 4024
GROUP BY ssblock.ss_block_id, ssblock.date_created, ssblock.date_updated, ssblock.deleted, ssblock.owner_user_pk1, ssblock.ss_framework_id, ssblock.ss_block_set_id, ssblock.start_datetime, ssblock.end_datetime, ssblock.max_slots
ORDER BY ssblock.start_datetime

-- this is unnecessary since we're joining to a slot_id, and there for at least 1 must exist
HAVING count(ssslot.ss_slot_id) > 0



 ssblock.deleted='N'
AND ssslot.user_pk1 = 2339
AND ssslot.ss_block_id = ssblock.ss_block_id 
GROUP BY ssblock.ss_block_id, ssblock.date_created, ssblock.date_updated, ssblock.deleted, ssblock.owner_user_pk1, ssblock.ss_framework_id, ssblock.ss_block_set_id, ssblock.start_datetime, ssblock.end_datetime, ssblock.max_slots
ORDER BY ssblock.start_datetime


SELECT *  FROM WMS_SS_FRAMEWORK



select ssblock.ss_block_id, ssblock.date_created, ssblock.date_updated, ssblock.deleted, ssblock.owner_user_pk1, ssblock.ss_framework_id, ssblock.ss_block_set_id, ssblock.start_datetime, ssblock.end_datetime, ssblock.max_slots, count(ssslot.ss_slot_id) as block_usage
FROM wms_ss_block ssblock, wms_ss_slot ssslot 
WHERE  ssblock.deleted='N'
 AND ssblock.ss_framework_id = 189
 AND ssblock.ss_block_id = ssslot.ss_block_id(+)
GROUP BY ssblock.ss_block_id, ssblock.date_created, ssblock.date_updated, ssblock.deleted, ssblock.owner_user_pk1, ssblock.ss_framework_id, ssblock.ss_block_set_id, ssblock.start_datetime, ssblock.end_datetime, ssblock.max_slots
ORDER BY ssblock.start_datetime
		

select * from users		

SELECT 
ssslot.ss_slot_id, ssslot.date_created, ssslot.date_updated, 
   ssslot.updated_by_user_pk1, ssslot.ss_block_id, 
   ssslot.user_pk1, u.user_id, u.firstname, u.lastname
FROM wms_ss_slot ssslot, users u
WHERE ssslot.deleted != 'Y'
  AND u.row_status = 0
  AND u.pk1 = ssslot.user_pk1
  AND ssslot.ss_block_id = 258
  
select *
from wms_ss_access

select * from course_users
  
select ssframework.*
from wms_ss_framework ssframework, wms_ss_access ssaccess
where
ssaccess.allowed_pk1=2339
and ssaccess.access_category='USER'
and ssframework.ss_framework_id = ssaccess.ss_framework_id
union
select ssframework.* 
from wms_ss_framework ssframework, wms_ss_access ssaccess, course_users cu
where cu.users_pk1 = 2339
and ssaccess.allowed_pk1=cu.crsmain_pk1
and ssaccess.access_category='COURSE'
and ssframework.ss_framework_id = ssaccess.ss_framework_id
order by 7


select ssblock.ss_block_id, ssblock.date_created, ssblock.date_updated, ssblock.deleted, ssblock.owner_user_pk1, ssblock.ss_framework_id, ssblock.ss_block_set_id, ssblock.start_datetime, ssblock.end_datetime, ssblock.max_slots, count(ssslot.ss_slot_id) as BLOCK_USAGE
FROM wms_ss_block ssblock
, wms_ss_slot ssslot
--, wms_ss_framework ssframework
WHERE  ssblock.deleted='N' 
AND ssblock.owner_user_pk1 = 2339
 AND ssblock.ss_block_id = ssslot.ss_block_id 
 GROUP BY ssblock.ss_block_id, ssblock.date_created, ssblock.date_updated, ssblock.deleted, ssblock.owner_user_pk1, ssblock.ss_framework_id, ssblock.ss_block_set_id, ssblock.start_datetime, ssblock.end_datetime, ssblock.max_slots
 ORDER BY ssblock.start_datetime
 
 
 select * from wms_ss_block
 
SELECT ssblock.ss_block_id, ssblock.date_created, ssblock.date_updated, ssblock.deleted, ssblock.owner_user_pk1, ssblock.ss_framework_id, ssblock.ss_block_set_id, ssblock.start_datetime, ssblock.end_datetime, ssblock.max_slots, count(ssslot.ss_slot_id) as BLOCK_USAGE
FROM wms_ss_block ssblock, wms_ss_slot ssslot 
WHERE  ssblock.deleted='N'
 AND ssblock.ss_framework_id = 295
 AND ssblock.ss_block_id = ssslot.ss_block_id(+)
 AND NOT EXISTS (select ss_slot_id from wms_ss_slot sss2 where sss2.ss_block_id = ssblock.ss_block_id and sss2.user_pk1=2339)
GROUP BY ssblock.ss_block_id, ssblock.date_created, ssblock.date_updated, ssblock.deleted, ssblock.owner_user_pk1, ssblock.ss_framework_id, ssblock.ss_block_set_id, ssblock.start_datetime, ssblock.end_datetime, ssblock.max_slots
HAVING ((count(ssslot.ss_slot_id) < ssblock.max_slots) OR (ssblock.max_slots=-1))
union
SELECT ssblock.ss_block_id, ssblock.date_created, ssblock.date_updated, ssblock.deleted, ssblock.owner_user_pk1, ssblock.ss_framework_id, ssblock.ss_block_set_id, ssblock.start_datetime, ssblock.end_datetime, ssblock.max_slots, -1 as BLOCK_USAGE
FROM wms_ss_block ssblock, wms_ss_slot ssslot 
WHERE  ssblock.deleted='N'
 AND ssblock.ss_framework_id = 295
 AND ssblock.ss_block_id = ssslot.ss_block_id
 AND ssslot.user_pk1 = 2339
ORDER BY start_datetime

-------------------------

SELECT 
   ssgroup.ss_group_id, ssgroup.date_created, ssgroup.date_updated, 
   ssgroup.owner_user_pk1, ssgroup.name, 
   ssgroup.description, ssgroup.max_total_slots_per_user, ssgroup.max_pending_slots_per_user
FROM wms_ss_framework ssframework, wms_ss_group ssgroup
WHERE ssframework.deleted != 'Y'
  AND ssgroup.deleted != 'Y'
  AND ssgroup.ss_group_id = ssframework.ss_group_id
  AND ssframework.ss_framework_id = 295

SELECT ssgroup.ss_group_id, count(ssslot.ss_slot_id) as group_usage
FROM wms_ss_group ssgroup, wms_ss_framework ssframework, wms_ss_block ssblock, wms_ss_slot ssslot
WHERE ssgroup.deleted != 'Y'
  AND ssframework.deleted != 'Y'
  AND ssblock.deleted != 'Y'
  AND ssslot.deleted != 'Y'
  AND ssgroup.ss_group_id = ssframework.ss_group_id
  AND ssframework.ss_framework_id = ssblock.ss_framework_id
  AND ssblock.ss_block_id = ssslot.ss_block_id
  AND ssgroup.ss_group_id = 315
  AND ssslot.user_pk1 = 2339
GROUP BY ssgroup.ss_group_id
  
SELECT ssframework.ss_framework_id, count(ssslot.ss_slot_id) as group_usage
FROM wms_ss_framework ssframework, wms_ss_block ssblock, wms_ss_slot ssslot
WHERE ssframework.deleted != 'Y'
  AND ssblock.deleted != 'Y'
  AND ssslot.deleted != 'Y'
  AND ssframework.ss_framework_id = ssblock.ss_framework_id
  AND ssblock.ss_block_id = ssslot.ss_block_id
  AND ssframework.ss_framework_id = 295
  AND ssslot.user_pk1 = 2339
GROUP BY ssframework.ss_framework_id
  

INSERT INTO wms_ss_group values() 
  
SELECT pk1 FROM course_main WHERE course_id = '06F-JAPN-101-01' AND row_status = 0

select * from wms_ss_access


select to_date('2005/08/31 14:32:23','YYYY/MM/DD HH24:MI:SS') from dual

select to_char(ssb.end_datetime,'HH24:MI'), ssb.* from wms_ss_block ssb
order by 1 desc 

where to_char(ssb.end_datetime,'HH:MI') = '12:00'

select * from wms_ss_vw_slot_nd

select distinct user_pk1 from wms_ss_vw_slot_nd

select * from wms_ss_vw_framework_nd

select distinct owner_user_pk1 from wms_ss_vw_framework_nd

select * from wms_ss_block where ss_block_id = 585

select *
from wms_ss_slot ssslot, wms_ss_block ssblock
where
ssblock.ss_block_id = ssslot.ss_block_id
and ssblock.ss_block_id = 585

update wms_ss_slot ssslot, wms_ss_block ssblock
set sslot.deleted = 'Y', ssblock.deleted='Y'
where
ssblock.ss_block_id = ssslot.ss_block_id
and ssblock.ss_block_id = 585

SELECT 
ss_block_id, date_created, date_updated, 
   deleted, owner_user_pk1, ss_framework_id, 
   ss_block_set_id, start_datetime, end_datetime, 
   max_slots
FROM wms_ss_block

SELECT 
ssb.ss_block_id, ssb.date_created, ssb.date_updated, 
ssb.deleted, ssb.owner_user_pk1, ssb.ss_framework_id, 
ssb.ss_block_set_id, ssb.start_datetime, ssb.end_datetime, 
ssb.max_slots, count(sss.ss_slot_id) as block_usage
FROM WMS_SS_VW_BLOCK_ND ssb, WMS_SS_VW_SLOT_ND sss
WHERE ssb.ss_block_id = sss.ss_block_id(+)
GROUP BY
ssb.ss_block_id, ssb.date_created, ssb.date_updated, 
ssb.deleted, ssb.owner_user_pk1, ssb.ss_framework_id, 
ssb.ss_block_set_id, ssb.start_datetime, ssb.end_datetime, 
ssb.max_slots

SELECT 
ss_group_id, 
date_created, 
date_updated, 
deleted, 
owner_user_pk1, 
name, 
description, 
max_total_slots_per_user, 
max_pending_slots_per_user
FROM wms_ss_group
WHERE deleted != 'Y'


SELECT ssblock.*
 FROM wms_ss_vw_block_use ssblock 
 WHERE ssblock.ss_framework_id = 928
 
 AND ((ssblock.max_slots = -1) OR (ssblock.max_slots > ssblock.block_usage))
					

select * from wms_ss_framework

update wms_ss_framework
set name = 'Spoo''s Office Hours'
where
ss_framework_id = 929

commit;

select
*
from
wms_ss_vw_group_nd

drop table wms_ss_group
			
			
			
select cu.pk1
	from course_users cu, bbsync_ps_course_users@card bbcu, users u, course_main c
	where cu.row_status != 0
	and c.pk1 = cu.crsmain_pk1
	and u.pk1 = cu.users_pk1
	and bbcu.course_id = c.course_id
	and bbcu.user_id = u.user_id
	
select u.pk1 from users u, bbsync_ps_users@card bbu
	where u.user_id = bbu.login_id
	and u.row_status != 0
	
	
4809

select ssblock.ss_block_id, ssblock.date_created, ssblock.date_updated, ssblock.deleted, ssblock.owner_user_pk1, ssblock.ss_framework_id, ssblock.ss_block_set_id, ssblock.start_datetime, ssblock.end_datetime, ssblock.max_slots, count(ssslot.ss_slot_id) as block_usage
FROM wms_ss_block ssblock, wms_ss_slot ssslot, wms_ss_framework ssframework, wms_ss_access ssaccess
WHERE  ssblock.deleted='N'
AND ssblock.ss_block_id = ssslot.ss_block_id
AND ssframework.ss_framework_id = ssblock.ss_framework_id
AND ssaccess.ss_framework_id = ssframework.ss_framework_id
AND ssaccess.access_category = 'COURSE'
AND ssaccess.allowed_pk1 = 4809
GROUP BY ssblock.ss_block_id, ssblock.date_created, ssblock.date_updated, ssblock.deleted, ssblock.owner_user_pk1, ssblock.ss_framework_id, ssblock.ss_block_set_id, ssblock.start_datetime, ssblock.end_datetime, ssblock.max_slots
ORDER BY ssblock.start_datetime

select * from course_main where pk1 = 2042

select * from users where lastname like 'Yamamoto'

3152

select * from wms_ss_vw_framework_nd
where
owner_user_pk1=3152

select *
from wms_ss_vw_block_nd
where
ss_framework_id in (6180,6181, 6210)

select * from wms_ss_access
where ss_framework_id in (6180,6181, 6210)