
select * from wms_ss_group

select * from wms_ss_framework

select * from wms_ss_block

select * from wms_ss_slot

select * from wms_ss_access

--------------

DECLARE
	group1_idnum NUMBER ;
	group2_idnum NUMBER ;
	framework1_idnum NUMBER ;
	framework2_idnum NUMBER ;
	framework3_idnum NUMBER ;
	framework4_idnum NUMBER ;
	block1_idnum NUMBER ;
	block2_idnum NUMBER ;
	block3_idnum NUMBER ;
	block4_idnum NUMBER ;
	block5_idnum NUMBER ;
	block6_idnum NUMBER ;
	slot1_idnum NUMBER ;
	slot2_idnum NUMBER ;
	slot3_idnum NUMBER ;
	slot4_idnum NUMBER ;
	slot5_idnum NUMBER ;
	slot6_idnum NUMBER ;
	access1_idnum NUMBER ;
	access2_idnum NUMBER ;
	access3_idnum NUMBER ;
	access4_idnum NUMBER ;
	access5_idnum NUMBER ;
	base_date DATE := SYSDATE+2;
BEGIN	
	delete from wms_ss_group;
	delete from wms_ss_framework;
	delete from wms_ss_block;
	delete from wms_ss_slot;
	delete from wms_ss_access;
	commit;
	--
	select wms_ss_ids.nextval into group1_idnum from dual;
	select wms_ss_ids.nextval into group2_idnum from dual;
	select wms_ss_ids.nextval into framework1_idnum from dual;
	select wms_ss_ids.nextval into framework2_idnum from dual;
	select wms_ss_ids.nextval into framework3_idnum from dual;
	select wms_ss_ids.nextval into framework4_idnum from dual;
	select wms_ss_ids.nextval into block1_idnum from dual;
	select wms_ss_ids.nextval into block2_idnum from dual;
	select wms_ss_ids.nextval into block3_idnum from dual;
	select wms_ss_ids.nextval into block4_idnum from dual;
	select wms_ss_ids.nextval into block5_idnum from dual;
	select wms_ss_ids.nextval into block6_idnum from dual;
	select wms_ss_ids.nextval into slot1_idnum from dual;
	select wms_ss_ids.nextval into slot2_idnum from dual;
	select wms_ss_ids.nextval into slot3_idnum from dual;
	select wms_ss_ids.nextval into slot4_idnum from dual;
	select wms_ss_ids.nextval into slot5_idnum from dual;
	select wms_ss_ids.nextval into slot6_idnum from dual;
	select wms_ss_ids.nextval into access1_idnum from dual;
	select wms_ss_ids.nextval into access2_idnum from dual;
	select wms_ss_ids.nextval into access3_idnum from dual;
	select wms_ss_ids.nextval into access4_idnum from dual;
	select wms_ss_ids.nextval into access5_idnum from dual;
--
	INSERT INTO wms_ss_group (
	   ss_group_id, date_created, date_updated, 
	   deleted, owner_user_pk1, name, 
	   description, max_total_slots_per_user, max_pending_slots_per_user,
	   is_default) 
	VALUES (
	   group1_idnum, base_date-2, base_date, 
	   'N', 2339, 'Test group 1', 
	   'This is the test group 1', 5, -1,
	   'Y');
--
	INSERT INTO wms_ss_group (
	   ss_group_id, date_created, date_updated, 
	   deleted, owner_user_pk1, name, 
	   description, max_total_slots_per_user, max_pending_slots_per_user,
	   is_default) 
	VALUES (
	   group2_idnum, base_date-2, base_date, 
	   'N', 2339, 'Test group 2', 
	   'This is the test group 2', 5, -1,
	   'N');
--
--
	INSERT INTO wms_ss_framework (
	   ss_framework_id, date_created, date_updated, 
	   deleted, owner_user_pk1, ss_group_id, 
	   name, description, max_total_slots_per_user, max_pending_slots_per_user, 
	   change_alert_owner_flag, imminent_alert_owner_flag,
	   signup_deadline, ss_resource, ss_location) 
	VALUES (framework1_idnum, base_date-2, base_date, 
	   'N', 2339, group1_idnum, 
	   'Test framework 1', 'This is test sheet framework 1, in group 1', 3, 1, 
	   'N','N',
	   null, 'Test ss resource/event', 'Test ss location');
--		
	INSERT INTO wms_ss_framework (
	   ss_framework_id, date_created, date_updated, 
	   deleted, owner_user_pk1, ss_group_id, 
	   name, description, max_total_slots_per_user, max_pending_slots_per_user, 
	   change_alert_owner_flag, imminent_alert_owner_flag,
	   signup_deadline, ss_resource, ss_location) 
	VALUES (framework2_idnum, base_date-2, base_date, 
	   'N', 2339, group1_idnum, 
	   'Test framework 2', 'This is test sheet framework 2, in group 1', 3, 1, 
	   'N','N',
	   null, 'Test ss resource/event', 'Test ss location');
--		
	INSERT INTO wms_ss_framework (
	   ss_framework_id, date_created, date_updated, 
	   deleted, owner_user_pk1, ss_group_id, 
	   name, description, max_total_slots_per_user, max_pending_slots_per_user, 
	   change_alert_owner_flag, imminent_alert_owner_flag,
	   signup_deadline, ss_resource, ss_location) 
	VALUES (framework3_idnum, base_date-2, base_date, 
	   'N', 2339, group2_idnum, 
	   'Test framework 3', 'This is test sheet framework 3, in group 2', 3, 1, 
	   'N','N',
	   null, 'Test ss resource/event', 'Test ss location');
--		
	INSERT INTO wms_ss_framework (
	   ss_framework_id, date_created, date_updated, 
	   deleted, owner_user_pk1, ss_group_id, 
	   name, description, max_total_slots_per_user, max_pending_slots_per_user, 
	   change_alert_owner_flag, imminent_alert_owner_flag,
	   signup_deadline, ss_resource, ss_location) 
	VALUES (framework4_idnum, base_date-1, base_date, 
	   'N', 2339, group1_idnum, 
	   'Test framework 4', 'This is test sheet framework 4, in group 1', 3, 2, 
	   'N','N',
	   null, 'Test ss resource/event', 'Test ss location');
--		
--		
	INSERT INTO wms_ss_block (
	   ss_block_id, date_created, date_updated, 
	   deleted, owner_user_pk1, ss_framework_id, 
	   ss_block_set_id, start_datetime, end_datetime, 
	   max_slots) 
	VALUES (block1_idnum, base_date-2, base_date-1, 
	   'N', 2339, framework1_idnum, 
	   1, trunc(base_date)-7+(10/24),trunc(base_date)-7+(11/24),  
	   2);
--		
	INSERT INTO wms_ss_block (
	   ss_block_id, date_created, date_updated, 
	   deleted, owner_user_pk1, ss_framework_id, 
	   ss_block_set_id, start_datetime, end_datetime, 
	   max_slots) 
	VALUES (block2_idnum, base_date-2, base_date-1, 
	   'N', 2339, framework1_idnum, 
	   1, trunc(base_date)-1+(11/24),trunc(base_date)-1+(12/24),  
	   1);
--		
	INSERT INTO wms_ss_block (
	   ss_block_id, date_created, date_updated, 
	   deleted, owner_user_pk1, ss_framework_id, 
	   ss_block_set_id, start_datetime, end_datetime, 
	   max_slots) 
	VALUES (block3_idnum, base_date-2, base_date-1, 
	   'N', 2339, framework1_idnum, 
	   1, trunc(base_date)+1+(10/24),trunc(base_date)+1+(11/24),  
	   1);
--		
	INSERT INTO wms_ss_block (
	   ss_block_id, date_created, date_updated, 
	   deleted, owner_user_pk1, ss_framework_id, 
	   ss_block_set_id, start_datetime, end_datetime, 
	   max_slots) 
	VALUES (block6_idnum, base_date-2, base_date-1, 
	   'N', 2339, framework1_idnum, 
	   1, trunc(base_date)+1+(11/24),trunc(base_date)+1+(12/24),  
	   1);
--		
	INSERT INTO wms_ss_block (
	   ss_block_id, date_created, date_updated, 
	   deleted, owner_user_pk1, ss_framework_id, 
	   ss_block_set_id, start_datetime, end_datetime, 
	   max_slots) 
	VALUES (block4_idnum, base_date-2, base_date, 
	   'N', 2339, framework1_idnum, 
	   2, trunc(base_date)+2+(14/24),trunc(base_date)+2+(14.5/24),  
	   2);
--		
	INSERT INTO wms_ss_block (
	   ss_block_id, date_created, date_updated, 
	   deleted, owner_user_pk1, ss_framework_id, 
	   ss_block_set_id, start_datetime, end_datetime, 
	   max_slots) 
	VALUES (block5_idnum, base_date-2, base_date, 
	   'N', 2339, framework1_idnum, 
	   3, trunc(base_date)+2+(14.75/24),trunc(base_date)+2+(16.5/24),  
	   -1);
--		
--
	INSERT INTO wms_ss_slot (
	   ss_slot_id, date_created, date_updated, 
	   deleted, updated_by_user_pk1, ss_block_id, 
	   user_pk1) 
	VALUES (
	   slot1_idnum, base_date-1.5, base_date-1, 
	   'N', 2339, block1_idnum, 
	   5418);
--
	INSERT INTO wms_ss_slot (
	   ss_slot_id, date_created, date_updated, 
	   deleted, updated_by_user_pk1, ss_block_id, 
	   user_pk1) 
	VALUES (
	   slot2_idnum, base_date-1.5, base_date-1, 
	   'N', 2339, block3_idnum, 
	   5418);
--
	INSERT INTO wms_ss_slot (
	   ss_slot_id, date_created, date_updated, 
	   deleted, updated_by_user_pk1, ss_block_id, 
	   user_pk1) 
	VALUES (
	   slot3_idnum, base_date-1.5, base_date-1, 
	   'N', 2339, block4_idnum, 
	   5418);
--
	INSERT INTO wms_ss_slot (
	   ss_slot_id, date_created, date_updated, 
	   deleted, updated_by_user_pk1, ss_block_id, 
	   user_pk1) 
	VALUES (
	   slot4_idnum, base_date-1.5, base_date-1, 
	   'N', 2339, block2_idnum, 
	   2339);
--
	INSERT INTO wms_ss_slot (
	   ss_slot_id, date_created, date_updated, 
	   deleted, updated_by_user_pk1, ss_block_id, 
	   user_pk1) 
	VALUES (
	   slot5_idnum, base_date-1.5, base_date-1, 
	   'N', 2339, block4_idnum, 
	   2339);
--
	INSERT INTO wms_ss_slot (
	   ss_slot_id, date_created, date_updated, 
	   deleted, updated_by_user_pk1, ss_block_id, 
	   user_pk1) 
	VALUES (
	   slot6_idnum, base_date-1.5, base_date-1, 
	   'N', 2339, block1_idnum, 
	   2339);
--	
--
	INSERT INTO wms_ss_access (
	   ss_access_id, date_created, date_updated, 
	   deleted, owner_user_pk1, ss_framework_id, 
	   allowed_pk1, access_category) 
	VALUES (
	   access1_idnum, base_date-2, base_date-2, 
	   'N', 2339, framework1_idnum, 
	   35, 'COURSE');
--	
	INSERT INTO wms_ss_access (
	   ss_access_id, date_created, date_updated, 
	   deleted, owner_user_pk1, ss_framework_id, 
	   allowed_pk1, access_category) 
	VALUES (
	   access2_idnum, base_date-2, base_date-2, 
	   'N', 2339, framework1_idnum, 
	   3393, 'USER');
--	
	INSERT INTO wms_ss_access (
	   ss_access_id, date_created, date_updated, 
	   deleted, owner_user_pk1, ss_framework_id, 
	   allowed_pk1, access_category) 
	VALUES (
	   access3_idnum, base_date-2, base_date-2, 
	   'N', 2339, framework2_idnum, 
	   2339, 'USER');
--	
	INSERT INTO wms_ss_access (
	   ss_access_id, date_created, date_updated, 
	   deleted, owner_user_pk1, ss_framework_id, 
	   allowed_pk1, access_category) 
	VALUES (
	   access4_idnum, base_date-2, base_date-2, 
	   'N', 2339, framework3_idnum, 
	   5418, 'USER');
--	
	INSERT INTO wms_ss_access (
	   ss_access_id, date_created, date_updated, 
	   deleted, owner_user_pk1, ss_framework_id, 
	   allowed_pk1, access_category) 
	VALUES (
	   access5_idnum, base_date-2, base_date-2, 
	   'N', 2339, framework3_idnum, 
	   4024, 'COURSE');
--	
	commit;		
END;

-- 2339 - Chris' PK 
-- 5418 - Comb's PK 
-- 3393 - Jnathan's PK 

-- 35 - Mika's test course PK 
-- 4024 - Chris' test course PK 

select (trunc(SYSDATE)+(14/24)) from dual


select * from users where lastname like '%Leamon%'

select trunc(sysdate)+1 from dual

--------------------

delete from wms_ss_group

delete from wms_ss_framework

delete from wms_ss_block

delete from wms_ss_slot

delete from wms_ss_access

commit

