<%@page import="java.util.*,
                java.text.*,
                java.io.*,
                blackboard.base.*,
                blackboard.base.BbList,
                blackboard.data.*,
                blackboard.data.announcement.*,
                blackboard.data.calendar.*,
                blackboard.data.course.*,
                blackboard.data.task.*,
                blackboard.data.user.*,
                blackboard.persist.*,
                blackboard.persist.announcement.*,
                blackboard.persist.calendar.*,
                blackboard.persist.course.*,
                blackboard.persist.task.*,
                blackboard.persist.user.*,
                blackboard.platform.*,
                blackboard.platform.session.*,
                blackboard.portal.data.*, 
                blackboard.portal.servlet.*,
                wms.ss.data.*,
                wms.ss.db.*,
                wms.ss.display.*"
        errorPage="/error.jsp"
%>
<%@ taglib uri="/bbData" prefix="bbData"%>
<%@ taglib uri="/bbUI" prefix="bbUI"%>

<bbData:context id="ctx">
<link type="text/css" rel="stylesheet" href="datetimepicker_style.css"/>
<bbUI:docTemplate>

<script language="javascript" type="text/javascript" src="datetimepicker.js">
</script>

<script language="javascript">
var allowDirectDateEdit=false;

function dayOfMonthToggler(theCaller, targetName)
{
  var targetField = document.getElementsByName(targetName).item(0);
  if (targetField.value == "yes")
  {
    theCaller.style.backgroundColor="#BBBBBB";
    targetField.value = "no";
  }
  else
  {
    theCaller.style.backgroundColor="#BBFFBB";
    targetField.value = "yes";
  }
  document.getElementById('IDrepeatRate3').checked = true;
}

// JS here to preset the dates?
</script>

<%
try
{
User curUser = ctx.getUser();
//String userPk = ctx.getUserId().toExternalString();
int userPkNum = DataUtil.getPkFromBbId(curUser.getId());// Integer.parseInt(userPk.substring(1,userPk.indexOf('_',1)));
String userName = curUser.getGivenName()+" "+curUser.getFamilyName();
String base_uri = blackboard.platform.plugin.PlugInUtil.getUriStem("wms", "wmss");

String frameworkIdStr = request.getParameter("frameworkId");
int frameworkId = Integer.parseInt(frameworkIdStr);
Framework curFramework = Framework.loadByFrameworkId(frameworkId);
String frameworkName = curFramework.getName();

String course_id = request.getParameter("course_id");

String dayChooserInitialText = "Click to select a day";
if (course_id != null)
{
%>
<bbUI:breadcrumbBar handle="course_tools_area">
    <bbUI:breadcrumb href="<%=base_uri + "ss_admin_class.jsp?course_id="+course_id%>">Signup Sheets</bbUI:breadcrumb>
    <bbUI:breadcrumb><%=frameworkName%></bbUI:breadcrumb>
</bbUI:breadcrumbBar>
<%
}
%>

<span style="float:left; font-size:18; font-weight:bold; font-family:arial, sans-serif; color:black;">Creating time blocks for <a href="<%=base_uri%>sheets/ss_admin_mod_sheet_step2.jsp?frameworkId=<%=frameworkId%><%=(course_id != null)?"&course_id="+course_id:""%>"><%=frameworkName%></a></span>
<br clear="all" />
(NOTE: you can do this multiple times for the same signup sheet)
<br>

<form action="<%=base_uri%>/sheets/ss_admin_cr_block_step2.jsp" method="PUT">
 <input type="hidden" name="frameworkId" value="<%=frameworkId%>">
<%
if (course_id != null)
{
    %> <input type="hidden" name="course_id" value="<%=course_id%>"><%
}
%>

<% String dateInputBgColor = "#bbbbbb"; %>
Starting on 
<input style="background-color:<%=dateInputBgColor%>;" id="IDonDay" name="onDay" type="text" onfocus="if (! allowDirectDateEdit) { this.blur(); }" value="" SIZE="10"> 
<input name="onDayButton" id="IDonDayButton" type="button" value="<%=dayChooserInitialText%>" 
       ondblclick="allowDirectDateEdit=true; alert('You can now directly enter the dates. The format is YYYY/MM/DD'); document.getElementById('IDonDay').focus();" 
       onclick="displayDatePicker('onDay', this, 'ymd', '/');"><br>
<br>
from <select id="IDstartTimeHour" name="startTimeHour">
<%
for (int i=0; i <= 11; i++)
{
    %><option value="<%=i%>" <%=(i==1)?"selected":""%>><%=(i==0)?"12":Integer.toString(i)%></option>
<%
}
%>
</select>:<select id="IDstartTimeMinute" name="startTimeMinute">
<%
for (int i=0; i < 60; i+=5)
{
    %><option value="<%=i%>" <%=(i==0)?"selected":""%>><%=((i<10)?"0":"")+Integer.toString(i)%></option>
<%
}
%>
</select> <select id="IDstartTimeAmPm" name="startTimeAmPm">
<option value="am">AM</option>
<option value="pm" selected>PM</option>
</select> to <select id="IDendTimeHour" name="endTimeHour">
<%
for (int i=0; i <= 11; i++)
{
    %><option value="<%=i%>" <%=(i==2)?"selected":""%>><%=(i==0)?"12":Integer.toString(i)%></option>
<%
}
%>
</select>:<select id="IDendTimeMinute" name="endTimeMinute">
<%
for (int i=0; i < 60; i+=5)
{
    %><option value="<%=i%>" <%=(i==0)?"selected":""%>><%=((i<10)?"0":"")+Integer.toString(i)%></option>
<%
}
%>
</select> <select id="IDendTimeAmPm" name="endTimeAmPm">
<option value="am">AM</option>
<option value="pm" selected>PM</option>
</select>
<br><br>
create <select name="numBlocksInTimeRange">
<%
for (int i=1; i < 24; i++)
{
    %><option value="<%=i%>" <%=(i==1)?"selected":""%>><%=(i==0)?"12":Integer.toString(i)%></option>
<%
}
%>
</select> block(s) and allowed up to <select id="IDnumSlotsPerBlock" name="numSlotsPerBlock">
<option value="-1">Unlimited</option>
<%
    for (int limitNum = 1; limitNum <= 120; limitNum++)
    {
        %><option value="<%=limitNum%>"<%=(limitNum==1?" selected":"")%>><%=limitNum%></option><%
    }
%>
</select> signup(s) for each block. 

<br><br>

<table border="1" cellspacing="0">
 <tr>
  <td align="center" colspan="3"><p style="font-size:14px;">Create the blocks</p></td>
 </tr>
 <tr>
  <td align="center"><input type="radio" id="IDrepeatRate1" name="repeatRate" value="1" checked></td>
  <td align="center"><input type="radio" id="IDrepeatRate2" name="repeatRate" value="2"></td>
  <td align="center"><input type="radio" id="IDrepeatRate3" name="repeatRate" value="3"></td>
 </tr>
 <tr>
  <td align="left" valign="top"><div style="padding-left:5px; padding-right:5px;">On this day only</div></td>
  <td align="left" valign="top"><div style="padding-left:5px; padding-right:5px;">Repeated on these days of the week:</div>
<blockquote>
<input type="checkbox" name="dowSunday" onclick="document.getElementById('IDrepeatRate2').checked = true;"> Sunday<br>
<input type="checkbox" name="dowMonday" onclick="document.getElementById('IDrepeatRate2').checked = true;"> Monday<br>
<input type="checkbox" name="dowTuesday" onclick="document.getElementById('IDrepeatRate2').checked = true;"> Tuesday<br>
<input type="checkbox" name="dowWednesday" onclick="document.getElementById('IDrepeatRate2').checked = true;"> Wednesday<br>
<input type="checkbox" name="dowThursday" onclick="document.getElementById('IDrepeatRate2').checked = true;"> Thursday<br>
<input type="checkbox" name="dowFriday" onclick="document.getElementById('IDrepeatRate2').checked = true;"> Friday<br>
<input type="checkbox" name="dowSaturday" onclick="document.getElementById('IDrepeatRate2').checked = true;"> Saturday<br>
</blockquote>
  <td align="left" valign="top"><div style="padding-left:5px; padding-right:5px;">Repeated on these days of the
 month (click to select):</div>
  <%
  String calButtonWidth = "37";
  String calButtonHeight = "23";
  %>
<%
for (int domnum = 1; domnum <= 31; domnum++)
{
      String domnumStr = Integer.toString(domnum);
      if (((domnum-1)%7)==0) // at beginning of a week
      {
          %><div style="text-align:left; padding-left:8px; padding-right:8px; padding-bottom:5px;">
<%
      }
      %><input style="font-size:12px; vertical-align:middle; text-align:center; background-color:#BBBBBB; width:<%=calButtonWidth%>px; height:<%=calButtonHeight%>;" name="dom<%=domnumStr%>Button" type="button" value="<%=domnumStr%>" onclick="dayOfMonthToggler(this, 'dom<%=domnumStr%>');">
<input type="hidden" name="dom<%=domnumStr%>" value="no">
<%
      if ((domnum%7)==0) // at end of a week
      {
          %></div>
<%
      }
}
%>
</div>
  </td>
 </tr>
 <tr>
  <td align="center" colspan="3"><span style="font-size:14px;">If repeated, repeat until </span>
<input style="background-color:<%=dateInputBgColor%>;" type="text" id="IDtilDay" name="tilDay" onfocus="if (! allowDirectDateEdit) { this.blur(); }" value="" size="10">
<input id="IDtilDayButton" name="tilDayButton" type="button" value="<%=dayChooserInitialText%>" ondblclick="allowDirectDateEdit=true; alert('You can now directly enter dates. The format is YYYY/MM/DD'); document.getElementById('IDtilDay').focus();" onclick="displayDatePicker('tilDay', this, 'ymd', '/');"> (<i>inclusive</i>)</td>
 </tr>
</table> 

<br><br>

<script language="javascript">
function validateBlockCreateData()
{
    <%/** make sure: an onDay is chosen, 
                   end time > start time, 
                   if not once only then a tilDay is chosen, 
                   if tilDay is chosen, tilDay >= onDay 
                   the number of slots per block is numeric and >= 1
    */%>
    var onDayItem = document.getElementById("IDonDay");
    if (onDayItem.value == "")
    {
        alert("You much choose a day");
        document.getElementById("IDonDayButton").focus();
        return false;
    }
    
    <%/**var tilDayItem = document.getElementById("IDtilDay");
    if ((tilDayItem.value == "") && ())
    {
        alert("You much choose a day to end");
        document.getElementById("IDtilDayButton").focus();
        return false;
    }*/%>

    var startTime = new Date();
    var endTime = new Date();
    var startHour = document.getElementById("IDstartTimeHour").value;
    if (document.getElementById("IDstartTimeAmPm").value == "pm") { startHour = startHour + 12; }
    var startMin = document.getElementById("IDstartTimeMinute").value;
    var endHour = document.getElementById("IDendTimeHour").value;
    if (document.getElementById("IDendTimeAmPm").value == "pm") { endHour = endHour + 12; }
    var endMin = document.getElementById("IDendTimeMinute").value;
    startTime.setHours(startHour, startMin);
    endTime.setHours(endHour, endMin);
    var isMac = navigator.userAgent.toLowerCase().indexOf("mac") != -1;
    if ((startTime.getTime() >= endTime.getTime()) && (! isMac))
    {
        alert("The end of the time range must be after the beginning");
        document.getElementById("IDendTimeHour").focus();
        return false;
    }
    
    //alert ("IDrepeatRate2 is "+document.getElementById("IDrepeatRate2").checked);
    //alert ("IDrepeatRate3 is "+document.getElementById("IDrepeatRate3").checked);
    
    if (document.getElementById("IDrepeatRate2").checked || document.getElementById("IDrepeatRate3").checked)
    {
        var tilDayItem = document.getElementById("IDtilDay");
        if (tilDayItem.value == "")
        {
            alert("You much choose a day to end the repitition");
            document.getElementById("IDtilDayButton").focus();
            return false;
        }
        if (onDayItem.value >= tilDayItem.value)
        {
            alert("The end repetion day must be after the start day");
            document.getElementById("IDtilDayButton").focus();
            return false;
        }
    }

    var slotsPerBlockItem = document.getElementById("IDnumSlotsPerBlock");
    var numSlotsStr = new String(slotsPerBlockItem.value);
    var numSlots = parseInt(numSlotsStr);
    if ((numSlotsStr.length < 1) || isNan(numSlots) || (numSlots <= 0))
    {
        alert("The number of slots must be a number and must be 1 or more");
        slotsPerBlockItem.focus();
        return false;
    }
    
    return true;
}
</script>

 <input style="font-size:16; font-weight:bold; font-family:arial, sans-serif;" type="submit" name="submitButton" value="Create the time blocks" onclick="return validateBlockCreateData();"> 
</form>
<%
}
catch (Exception e)
{
    %><hr><pre><%=e.toString()%></pre><%
    StackTraceElement[] theStackTrace = e.getStackTrace();
    for (int i = 0; i < theStackTrace.length; i++)
    {
        %><%=theStackTrace[i].toString()%><br><%
    }
}
%>

</bbUI:docTemplate>
</bbData:context>

