<%@page import="java.util.*,
                java.text.*,
                java.io.*,
                blackboard.base.*,
                blackboard.base.BbList,
                blackboard.data.*,
                blackboard.data.announcement.*,
                blackboard.data.calendar.*,
                blackboard.data.course.*,
                blackboard.data.task.*,
                blackboard.data.user.*,
                blackboard.persist.*,
                blackboard.persist.announcement.*,
                blackboard.persist.calendar.*,
                blackboard.persist.course.*,
                blackboard.persist.task.*,
                blackboard.persist.user.*,
                blackboard.platform.*,
                blackboard.platform.session.*,
                blackboard.portal.data.*, 
                blackboard.portal.servlet.*,
                wms.ss.data.*,
                wms.ss.db.*"
        errorPage="/error.jsp"
%><%@ taglib uri="/bbData" prefix="bbData"%><%@ taglib uri="/bbUI" prefix="bbUI"%><bbData:context id="ctx"><%
try 
{
User curUser = ctx.getUser();
String userPk = ctx.getUserId().toExternalString();
int userPkNum = Integer.parseInt(userPk.substring(1,userPk.indexOf('_',1)));
String userName = curUser.getGivenName()+" "+curUser.getFamilyName();
String base_uri = blackboard.platform.plugin.PlugInUtil.getUriStem("wms", "wmss");

String course_id = request.getParameter("course_id");

SheetGroup defaultGroup = SheetGroup.loadDefaultForOwnerId(userPkNum);
if (defaultGroup.getGroupId() == 0)
{
    // no default group exists, create one
    defaultGroup.setOwnerUserPk1(userPkNum);
    defaultGroup.setName(SheetGroup.defaultGroupName);
    defaultGroup.setDescription("This is the default sheet group for "+userName);
    defaultGroup.setMaxTotalSlotsPerUser(-1);
    defaultGroup.setMaxPendingSlotsPerUser(-1);
    defaultGroup.setIsDefault(true);
    defaultGroup.saveNew();
}

Framework frameworkScaffold = new Framework();
frameworkScaffold.setGroupId(defaultGroup.getGroupId());
frameworkScaffold.setOwnerUserPk1(userPkNum);
frameworkScaffold.setName("New signup sheet");
frameworkScaffold.setDescription("A brief description of the new signup sheet");
frameworkScaffold.setMaxTotalSlotsPerUser(-1);
frameworkScaffold.setMaxPendingSlotsPerUser(-1);
frameworkScaffold.setChangeAlertOwnerFlag("N");
frameworkScaffold.setImminentAlertOwnerFlag("N");
frameworkScaffold.setSignupDeadline(null);
frameworkScaffold.setLocation("");
frameworkScaffold.setResource("");
frameworkScaffold.saveNew();

//String redirectUrl = base_uri + "sheets/ss_admin_mod_sheet_step1.jsp?isNew=true&frameworkId=" + Integer.toString(frameworkScaffold.getFrameworkId());
String redirectUrl = "ss_admin_mod_sheet_step1.jsp?isNew=true&frameworkId=" + Integer.toString(frameworkScaffold.getFrameworkId())+ ((course_id != null)?("&course_id="+course_id):"");
%><jsp:forward page="<%= redirectUrl %>" />

<%
}
catch (Exception e)
{
    %><hr><pre><%=e.toString()%></pre><%
    StackTraceElement[] theStackTrace = e.getStackTrace();
    for (int i = 0; i < theStackTrace.length; i++)
    {
        %><%=theStackTrace[i].toString()%><br><%
    }
}
%>
</bbData:context>

