<%@page import="java.util.*,
                java.text.*,
                java.io.*,
                java.sql.*,
                blackboard.base.*,
                blackboard.base.BbList,
                blackboard.data.*,
                blackboard.data.announcement.*,
                blackboard.data.calendar.*,
                blackboard.data.course.*,
                blackboard.data.task.*,
                blackboard.data.user.*,
                blackboard.db.*,
                blackboard.persist.*,
                blackboard.persist.announcement.*,
                blackboard.persist.calendar.*,
                blackboard.persist.course.*,
                blackboard.persist.Id.*,
                blackboard.persist.PkId.*,
                blackboard.persist.task.*,
                blackboard.persist.user.*,
                blackboard.platform.*,
                blackboard.platform.session.*,
                blackboard.portal.data.*, 
                blackboard.portal.servlet.*,
                wms.ss.data.*,
                wms.ss.db.*,
                wms.ss.display.*"
        errorPage="/error.jsp"
%>
<%@ taglib uri="/bbData" prefix="bbData"%>
<%@ taglib uri="/bbUI" prefix="bbUI"%>

<bbData:context id="ctx">
<link type="text/css" rel="stylesheet" href="datetimepicker_style.css"/>
<bbUI:docTemplate>

<script language="javascript" type="text/javascript" src="datetimepicker.js">
</script>

<script language="javascript" type="text/javascript">
var allowDirectDateEdit=false;

function hidePastDays ()
{
    var pastDayElements = document.getElementsByName('<%=HtmlCalendarTool.pastDayTimingName%>');
    for (var i = 0; i < pastDayElements.length; i++)
    {
        pastDayElements[i].style.display="none";
    }
}

function showPastDays ()
{
    var pastDayElements = document.getElementsByName('<%=HtmlCalendarTool.pastDayTimingName%>');
    for (var i = 0; i < pastDayElements.length; i++)
    {
        pastDayElements[i].style.display="block";
    }
}

function validateMultiDelete ()
{
    var debugMe = 0;
    var sd = document.getElementById('IDmultiDeleteStartDate').value;
    if (debugMe == 1) { alert("sd="+sd); }
    if (sd == "")
    {
        alert("You much choose a start day");
        document.getElementById("IDmultiDeleteStartDateButton").focus();
        return false;
    }

    var ed = document.getElementById('IDmultiDeleteEndDate').value;
    if (debugMe == 1) { alert("ed="+ed); }
    if (ed == "")
    {
        alert("You much choose an end day");
        document.getElementById("IDmultiDeleteEndDateButton").focus();
        return false;
    }

    var startTime = new Date();
    var endTime = new Date();
    var startHour = document.getElementById("IDstartTimeHour").value;
    if (document.getElementById("IDstartTimeAmPm").value == "pm") { startHour = startHour + 12; }
    var startMin = document.getElementById("IDstartTimeMinute").value;
    var endHour = document.getElementById("IDendTimeHour").value;
    if (document.getElementById("IDendTimeAmPm").value == "pm") { endHour = endHour + 12; }
    var endMin = document.getElementById("IDendTimeMinute").value;
    startTime.setHours(startHour, startMin);
    endTime.setHours(endHour, endMin);
    var isMac = navigator.userAgent.toLowerCase().inexOf("mac") != -1;
    if (debugMe == 1) { alert("isMac="+isMac); }
    if (debugMe == 1) { alert("startTime.getTime()="+startTime.getTime()); }
    if (debugMe == 1) { alert("endTime.getTime()="+endTime.getTime()); }
    if ((startTime.getTime() >= endTime.getTime()) && (! isMac))
    {
        alert("The end of the time range must be after the beginning");
        document.getElementById("IDendTimeHour").focus();
        return false;
    }

    if (debugMe == 1) { alert("form is valid"); }
    return true;
}
</script>

<%
try
{
User curUser = ctx.getUser();
//String userPk = ctx.getUserId().toExternalString();
int userPkNum = DataUtil.getPkFromBbId(curUser.getId());// Integer.parseInt(userPk.substring(1,userPk.indexOf('_',1)));
String userName = curUser.getGivenName()+" "+curUser.getFamilyName();
String base_uri = blackboard.platform.plugin.PlugInUtil.getUriStem("wms", "wmss");

String frameworkIdStr = request.getParameter("frameworkId");
int frameworkId = Integer.parseInt(frameworkIdStr);
Framework curFramework = Framework.loadByFrameworkId(frameworkId);
String frameworkName = curFramework.getName();

String course_id = request.getParameter("course_id");

String blockIdStr = request.getParameter("blockId");
int blockId = (blockIdStr == null)?0:Integer.parseInt(blockIdStr);

if (course_id != null)
{
%>
<bbUI:breadcrumbBar handle="course_tools_area">
    <bbUI:breadcrumb href="<%=base_uri + "ss_admin_class.jsp?course_id="+course_id%>">Signup Sheets</bbUI:breadcrumb>
    <bbUI:breadcrumb><%=frameworkName%></bbUI:breadcrumb>
</bbUI:breadcrumbBar>
<%
}



%>
<table>
 <tr>
  <td width="800">
<%
String errMsg = request.getParameter("errorMessage");
errMsg = (errMsg == null)?"":errMsg;
if (errMsg.length() > 0)
{
    %><p style="font: bold 14pt; color:red;"><%=errMsg%></p><%
}
%>
  
<span style="float:left; font-size:24; font-weight:bold; font-family:arial, sans-serif; color:black;">Time blocks for <a href="<%=base_uri%>sheets/ss_admin_mod_sheet_step1.jsp?frameworkId=<%=frameworkId%><%=(course_id != null)?"&course_id="+course_id:""%>"><%=frameworkName%></a></span>
<form style="float:right;" action="<%=base_uri%>/sheets/ss_admin_cr_block_step1.jsp" method="GET">
<%
if (course_id != null)
{
    %> <input type="hidden" name="course_id" value="<%=course_id%>"><%
}
%>
 <input type="hidden" name="frameworkId" value="<%=frameworkId%>">
 <input style="font-size:16; font-family:arial, sans-serif;" type="submit" name="submitButton" value="Add new time blocks to this sheet">
</form>
<br /><br /><br />
<input id="hidePastDaysButton" type="button" value="Hide days in the past" onclick="var theButton = getElementById('hidePastDaysButton'); theButton.style.display='none'; theButton = getElementById('showPastDaysButton'); theButton.style.display='block'; hidePastDays();">
<input id="showPastDaysButton" type="button" value="Show days in the past" onclick="var theButton = getElementById('hidePastDaysButton'); theButton.style.display='block'; theButton = getElementById('showPastDaysButton'); theButton.style.display='none'; showPastDays();" style="display: none;">

<!-- NOTE: removed multi-delete stuff from here on 2006/06/12 -->

<center>
<%
BlockList blocks = BlockList.loadByFrameworkId(frameworkId);
HtmlCalendarTool hct = new HtmlCalendarTool();
Block lastBlock = null;
for (int blockIndex = 0; blockIndex < blocks.size(); blockIndex++)
{
    Block curBlock = (Block)blocks.get(blockIndex);
    String htmlForTimeBetween = "";
    if (lastBlock==null)
    {
        out.print(hct.startCalendar(curBlock.getStartDatetime()));
    }
    else
    {
        htmlForTimeBetween = hct.emptyTimeBetween(lastBlock.getEndDatetime(),curBlock.getStartDatetime());
        out.print(htmlForTimeBetween);
    }
    String timing = hct.hourMinFormatter.format(curBlock.getStartDatetime()) + "-" + 
            hct.hourMinAmPmFormatter.format(curBlock.getEndDatetime());
    String maxSlotsText = (curBlock.getMaxSlots()<0)?"*":Integer.toString(curBlock.getMaxSlots());
    %><hr />
<%
    boolean endBlockDiv = false;
    if (blockId == curBlock.getBlockId()) // highlight last used/acted-on block
    {
        %><div style="background-color:#BBBBFF;"><%
        endBlockDiv = true;
    } else if (curBlock.getUsedSlots() >= 1) {  // highlight blocks that have signups
        %><div style="background-color:#BBFFFF;"><%
        endBlockDiv = true;
    }
%>
<p style="<%=hct.getCurDayTextStyle()%>">
<a href="<%=base_uri%>sheets/ss_admin_mod_block.jsp?blockId=<%=curBlock.getBlockId()%>&frameworkId=<%=frameworkId%><%=(course_id != null)?"&course_id="+course_id:""%>"><%=timing%></a>
(<a title="Delete this block" style="color:red;" href="<%=base_uri%>sheets/ss_admin_del_block.jsp?blockId=<%=curBlock.getBlockId()%>&frameworkId=<%=frameworkId%><%=(course_id != null)?"&course_id="+course_id:""%>"  onclick="return confirm('You are about to delete the block and all associated signups. Click OK to do so, and Cancel to abort.')"><b>X</b></a>)<br />
<%=curBlock.getUsedSlots()%>(<a title="Sign someone up" style="color:green;" href="<%=base_uri%>slot_signups/ss_admin_signup_step1.jsp?blockId=<%=curBlock.getBlockId()%>&frameworkId=<%=frameworkId%><%=(course_id != null)?"&course_id="+course_id:""%>"><b>+</b></a>)/<%=maxSlotsText%><br />
<%
    if (curBlock.getUsedSlots() > 0)
    {
        SlotSignupList ssl = SlotSignupList.loadByBlockId(curBlock.getBlockId());
        for (int ssIndex = 0; ssIndex < ssl.size(); ssIndex++)
        {
            SlotSignup ss = (SlotSignup)ssl.get(ssIndex);            
            %><li style="<%=hct.getCurDayTextStyle()%>"><%=ss.getUserFirstName()%>&nbsp;<%=ss.getUserLastName()%>(<a title="Delete this signup" style="color:#CC6633;" href="<%=base_uri%>slot_signups/ss_admin_del_signup.jsp?slotSignupId=<%=ss.getSlotSignupId()%>&blockId=<%=curBlock.getBlockId()%>&frameworkId=<%=frameworkId%><%=(course_id != null)?"&course_id="+course_id:""%>"   onclick="return confirm('You are about to delete the signup. Click OK to do so, and Cancel to abort.')"><b>X</b></a>)</li>
<%
        }
    }        
    if (endBlockDiv)
    {
        %></div><%
    }
    
    lastBlock = curBlock;
}
if (blocks.size() > 0) {
    out.print(hct.endCalendar(lastBlock.getEndDatetime()));
} else {
    %><span style="font-size:16pt;">This sheet has no time blocks set up yet.</span><%
}
%>
</center>
 
  </td>
 </tr>
</table>
<%
}
catch (Exception e)
{
    %><hr><pre><%=e.toString()%></pre><%
    StackTraceElement[] theStackTrace = e.getStackTrace();
    for (int i = 0; i < theStackTrace.length; i++)
    {
        %><%=theStackTrace[i].toString()%><br><%
    }
}
%>

</bbUI:docTemplate>
</bbData:context>

