<%@page import="java.util.*,
                java.text.*,
                java.io.*,
                blackboard.base.*,
                blackboard.base.BbList,
                blackboard.data.*,
                blackboard.data.announcement.*,
                blackboard.data.calendar.*,
                blackboard.data.course.*,
                blackboard.data.task.*,
                blackboard.data.user.*,
                blackboard.persist.*,
                blackboard.persist.announcement.*,
                blackboard.persist.calendar.*,
                blackboard.persist.course.*,
                blackboard.persist.task.*,
                blackboard.persist.user.*,
                blackboard.platform.*,
                blackboard.platform.session.*,
                blackboard.portal.data.*, 
                blackboard.portal.servlet.*,
                wms.ss.data.*,
                wms.ss.db.*"
        errorPage="/error.jsp"
%>
<%@ taglib uri="/bbData" prefix="bbData"%>
<%@ taglib uri="/bbUI" prefix="bbUI"%>

<bbData:context id="ctx">
<bbUI:docTemplate>
<%
User curUser = ctx.getUser();
String userPk = ctx.getUserId().toExternalString();
int userPkNum = Integer.parseInt(userPk.substring(1,userPk.indexOf('_',1)));
String userName = curUser.getGivenName()+" "+curUser.getFamilyName();
String base_uri = blackboard.platform.plugin.PlugInUtil.getUriStem("wms", "wmss");
String course_id = request.getParameter("course_id");

if (course_id != null)
{
%>
<bbUI:breadcrumbBar handle="course_tools_area">
    <bbUI:breadcrumb>Signup Sheets</bbUI:breadcrumb>
</bbUI:breadcrumbBar>
<%
}
%>


<span style="font-size:16pt;">Signup sheets accessible by <%=userName%>:</span>

<ul>
<%
FrameworkList fl = wms.ss.data.FrameworkList.loadByAccessUserId(userPkNum);
Iterator fli = fl.listIterator();

if (fl.isEmpty())
{
    %><li>No signup sheets accessible</li><%
}
else 
{
    while (fli.hasNext())
    {
            Framework f = (Framework)fli.next();
            String fName = f.getName();
            int frameworkId = f.getFrameworkId();
            %><li><a href="<%=base_uri%>sheets/ss_user_vw_sheet_step1.jsp?frameworkId=<%=frameworkId%>"><%=fName%></a></li><%
    }
}
%>
</ul>

</bbUI:docTemplate>
</bbData:context>

