<%@page import="java.util.*,
                java.text.*,
                java.sql.*,
                java.io.*,
                java.net.URLDecoder,
                java.net.URLEncoder,
                blackboard.base.*,
                blackboard.base.BbList,
                blackboard.data.*,
                blackboard.data.announcement.*,
                blackboard.data.calendar.*,
                blackboard.data.course.*,
                blackboard.data.task.*,
                blackboard.data.user.*,
                blackboard.db.*,
                blackboard.persist.*,
                blackboard.persist.announcement.*,
                blackboard.persist.calendar.*,
                blackboard.persist.course.*,
                blackboard.persist.task.*,
                blackboard.persist.user.*,
                blackboard.platform.*,
                blackboard.platform.session.*,
                blackboard.portal.data.*, 
                blackboard.portal.servlet.*,
                wms.email.*,
                wms.ss.data.*,
                wms.ss.db.*,
                wms.ss.display.*"
        errorPage="/error.jsp"
%><%@ taglib uri="/bbData" prefix="bbData"%><%@ taglib uri="/bbUI" prefix="bbUI"%><bbData:context id="ctx"><%
try
{
User curUser = ctx.getUser();
int userPkNum = DataUtil.getPkFromBbId(curUser.getId());
String userName = curUser.getGivenName()+" "+curUser.getFamilyName();
String base_uri = blackboard.platform.plugin.PlugInUtil.getUriStem("wms", "wmss");

String course_id = request.getParameter("course_id");

String coursePkStr = request.getParameter("coursePk");
int coursePkNum = 0;
if (coursePkStr != null)
{
    coursePkNum = Integer.parseInt(coursePkStr);
}


String frameworkIdStr = request.getParameter("frameworkId");
if (frameworkIdStr == null)
{
    %>
<bbUI:docTemplate>
<%
if (course_id != null)
{
%>
<bbUI:breadcrumbBar handle="course_tools_area">
    <bbUI:breadcrumb href="<%=base_uri + "ss_admin_class.jsp?course_id="+course_id%>">Signup Sheets</bbUI:breadcrumb>
</bbUI:breadcrumbBar>
<%
}
%>
<span style="font-size:16pt;">Sign someone up for which sheet?</span><br>
<%
    FrameworkList fl = null;
    if (coursePkNum != 0)
    {
        fl = wms.ss.data.FrameworkList.loadByCourseId(coursePkNum);
    }
    else
    {
        fl = wms.ss.data.FrameworkList.loadByOwnerUserId(userPkNum);
    }
    Iterator fli = fl.listIterator();

    if (fl.isEmpty())
    {
        %>No signup sheets owned. You must <a href="<%=base_uri%>sheets/ss_admin_cr_sheet_step1.jsp?<%=(course_id != null)?"&course_id="+course_id:""%>">create one</a> first.<%
    }
    else 
    {
        while (fli.hasNext())
        {
                Framework f = (Framework)fli.next();
                // find out if the sheet has any block, and if not then don't display it, or display with an appropriate message
                // find out if the sheet has any open blocks, and if not then do approp message
                String frameworkMessage = "";
                if (f.getNumberOfBlocks() < 1)
                {
                    frameworkMessage = "<span style=\"color: red; font-weight: bold;\">This sheet has no time blocks defined! Create some so people can use the sheet.</span>";
                }
                else if (f.getNumberOfOpenBlocks() < 1)
                {
                    frameworkMessage = "<span style=\"color: maroon; font-weight: bold;\">This sheet has no open space in its blocks, though you may override normal limits.</span>";
                }
                String fName = f.getName();
                int frameworkId = f.getFrameworkId();
                %><a href="<%=base_uri%>sheets/ss_admin_mod_sheet_step2.jsp?frameworkId=<%=frameworkId%><%=(course_id != null)?"&course_id="+course_id:""%>"><%=fName%></a> <%=frameworkMessage%><br /><%
        }
    }
%>
</bbUI:docTemplate>
<%
}
int frameworkId = Integer.parseInt(frameworkIdStr);
Framework curFramework = Framework.loadByFrameworkId(frameworkId);
String frameworkName = curFramework.getName();

String redirectUrl = "../sheets/ss_admin_mod_sheet_step2.jsp?frameworkId=" + frameworkIdStr + ((course_id != null)?("&course_id="+course_id):"");

String blockIdStr = request.getParameter("blockId");
if (blockIdStr == null)
{
    // forward to the block display for that framework
    %><jsp:forward page="<%= redirectUrl %>" /><%
}
int blockId = Integer.parseInt(blockIdStr);
HtmlCalendarTool hct = new HtmlCalendarTool();
Block curBlock = Block.loadByBlockId(blockId);
String blockDate = hct.dayOfWeekDateFormatter.format(curBlock.getStartDatetime()) + ", " +
hct.downToDayDateFormatter.format(curBlock.getStartDatetime());
String blockTiming = hct.hourMinAmPmFormatter.format(curBlock.getStartDatetime()) + "-" + 
        hct.hourMinAmPmFormatter.format(curBlock.getEndDatetime());

// now know the framework and block, just have to deal with the userId
String signUpUserIdStr = request.getParameter("signUpUserId");
if (signUpUserIdStr == null)
{
    %><bbUI:docTemplate>
<%
if (course_id != null)
{
%>
<bbUI:breadcrumbBar handle="course_tools_area">
    <bbUI:breadcrumb href="<%=base_uri + "ss_admin_class.jsp?course_id="+course_id%>">Signup Sheets</bbUI:breadcrumb>
    <bbUI:breadcrumb><%=frameworkName%></bbUI:breadcrumb>
</bbUI:breadcrumbBar>
<%
}
    String errorMessage = request.getParameter("errorMessage");
    if (errorMessage != null)
    {
        errorMessage = URLDecoder.decode(errorMessage,"UTF-8");
        %><p style="font-size: 16pt; color: red; font-family: arial, sans-serif;">
        <%=errorMessage%>
        </p>
<%
    }
    %>
     <br><br>
    <p style="font-size: 14pt; font-weight: bold; font-family: arial, sans-serif;">
Enter the User ID of the person to be signed up for a slot in the<br />
<%=blockDate%> <%=blockTiming%> time block of the sheet <%=curFramework.getName()%>.
    </p>
    <form action="<%=base_uri%>slot_signups/ss_admin_signup_step1.jsp" method="GET">
     <input type="hidden" name="frameworkId" value="<%=frameworkIdStr%>">
     <input type="hidden" name="blockId" value="<%=blockIdStr%>">
<%
if (course_id != null)
{
%>
     <input type="hidden" name="course_id" value="<%=course_id%>">
<%
}
%>
     <input type="text" name="signUpUserId" value="" size="16" maxlength="16">
     <br><br>
     <input style="font-size: 18pt; font-weight: bold; font-family: arial, sans-serif;" type="submit" name="submitButton" value="Sign them up">
    </form>
 
   <hr>
   
   <b>Search for a user ID</b> (you must enter at least part of at least one of first name or last name)
    <form action="<%=base_uri%>slot_signups/ss_admin_signup_step1.jsp" method="GET">
     <input type="hidden" name="frameworkId" value="<%=frameworkIdStr%>">
     <input type="hidden" name="blockId" value="<%=blockIdStr%>">
<%
if (course_id != null)
{
%>
     <input type="hidden" name="course_id" value="<%=course_id%>">
<%
}
%>
    <table>
     <tr>
      <td>First Name:</td>
      <td><input type="text" name="search_fname" value="" size="24" maxlength="48"> (leave blank if unknown and/or irrelevant)</td>
     </tr>
     <tr>
      <td>Last Name:</td>
      <td><input type="text" name="search_lname" value="" size="24" maxlength="48"> (leave blank if unknown and/or irrelevant)</td>
     </tr>
    </table>
     <input style="font-size: 14pt; font-family: arial, sans-serif;" type="submit" name="submitButton" value="Search">
    </form>
    <%
    // do the actual searching based on the parameters from the previous page
    String search_fname = "";
    String search_lname = "";
    String param_search_fname = request.getParameter("search_fname");
    String param_search_lname = request.getParameter("search_lname");
    if (param_search_fname != null) { search_fname = param_search_fname.trim(); }
    if (param_search_lname != null) { search_lname = param_search_lname.trim(); }
    if ((search_fname.length() > 0) || (search_lname.length() > 0))
    {
        String search_sql =
                "SELECT firstname, lastname, user_id " +
                "FROM users " +
                "WHERE row_status = 0 " +
                " AND upper(firstname) like '"+search_fname.toUpperCase()+"%' " +
                " AND upper(lastname) like '"+search_lname.toUpperCase()+"%' " +
                "ORDER BY lastname, firstname";
        ConnectionManager bbConnMgr = Connect.getConnectionManager();
        java.sql.Connection conn = Connect.getConnection(bbConnMgr);
        Statement sql = conn.createStatement(ResultSet.TYPE_FORWARD_ONLY, ResultSet.CONCUR_READ_ONLY);
        ResultSet res = sql.executeQuery(search_sql);
        %><table>
        <%
        while (res.next())
        {
            String u_fname   = res.getString("firstname");
            String u_lname   = res.getString("lastname");
            String u_user_id = res.getString("user_id");
            %> <tr><td align="right"><%=u_fname%> <%=u_lname%> is</td><td><%=u_user_id%></td></tr>
            <%
        }
        %></table>
        <%
        sql.close();
        if(bbConnMgr != null) {
            bbConnMgr.releaseConnection(conn);
        }
    }
    %>
    
    
    </bbUI:docTemplate>
<%
}

// check for valid userID, if invalid forward to this with approp error message
int signUpUserPk = DataUtil.getUserPkFromUserId(signUpUserIdStr);
if (signUpUserPk==0) // userId is invalid, got a PK of 0
{
    String invalidUserIdMsg = "Sorry, the signup cannot be completed because the user id '"+signUpUserIdStr+"' is not valid.";
    //String encodedInvalidUserIdMsg = URLEncoder.encode(invalidUserIdMsg,"UTF-8");
    //redirectUrl = base_uri + "slot_signups/ss_admin_signup_step1.jsp?frameworkId=" + frameworkIdStr+"&blockId=" + blockIdStr + "&errorMessage="+encodedInvalidUserIdMsg;
    // for some totally unknown reason, jsp:forward-ing is nto working here. Resorting to use of an intermediate page - less than ideal, but on the plus side it actually works.
    %>
<bbUI:docTemplate>
<%
if (course_id != null)
{
%>
<bbUI:breadcrumbBar handle="course_tools_area">
    <bbUI:breadcrumb href="<%=base_uri + "ss_admin_class.jsp?course_id="+course_id%>">Signup Sheets</bbUI:breadcrumb>
    <bbUI:breadcrumb><%=frameworkName%></bbUI:breadcrumb>
</bbUI:breadcrumbBar>
<%
}
%>
<p style="font-size: 16pt; color: red; font-family: arial, sans-serif;"><%=invalidUserIdMsg%></p>
<br>
<p style="font-size: 16pt; color:black; font-family: arial, sans-serif;">Please <a href="<%=base_uri%>slot_signups/ss_admin_signup_step1.jsp?frameworkId=<%=frameworkIdStr%>&blockId=<%=blockIdStr%><%=(course_id != null)?"&course_id="+course_id:""%>">try again with a different user id</a>.</p>
</bbUI:docTemplate>
<%
}
else
{
    try
    {
        // at this point, have frameworkID, blockID, and signUpUserPk
        // create the sslotsignup, then forward to sheet block display with the given block highlighted
        SlotSignup ss = new SlotSignup();
        ss.setBlockId(blockId);
        ss.setUpdatedByUserPk1(userPkNum);
        ss.setUserPk1(signUpUserPk);
        ss.setAdminComment(" ");
        ss.saveNew();
        if (ss.getSlotSignupId() == -1)
        {
            // a -1 for the slot id indicates the user already has a signup on that block
            // so set the appropriate error message and all the other parameters and
            // redirect to self again
    %>
<bbUI:docTemplate>
<%
if (course_id != null)
{
%>
<bbUI:breadcrumbBar handle="course_tools_area">
    <bbUI:breadcrumb href="<%=base_uri + "ss_admin_class.jsp?course_id="+course_id%>">Signup Sheets</bbUI:breadcrumb>
    <bbUI:breadcrumb><%=frameworkName%></bbUI:breadcrumb>
</bbUI:breadcrumbBar>
<%
}
%>
<p style="font-size: 16pt; color: red; font-family: arial, sans-serif;">That user has already signed up for this time block.</p>
<br>
<p style="font-size: 16pt; color:black; font-family: arial, sans-serif;">Please <a href="<%=base_uri%>slot_signups/ss_admin_signup_step1.jsp?frameworkId=<%=frameworkIdStr%>&blockId=<%=blockIdStr%><%=(course_id != null)?"&course_id="+course_id:""%>">try again with a different user id</a>.</p>
</bbUI:docTemplate>
<%
        }
        else
        {
            ss = SlotSignup.loadBySlotSignupId(ss.getSlotSignupId()); // loads all auxiliary info

            ss.emailAddAlertToUser();
            redirectUrl = "../sheets/ss_admin_mod_sheet_step2.jsp?frameworkId=" + frameworkIdStr + "&blockId=" + blockIdStr + ((course_id != null)?("&course_id="+course_id):"");
            %><jsp:forward page="<%= redirectUrl %>" /><%
        }
    }
    catch (Exception e)
    {
        %><hr><pre><%=e.toString()%></pre><%
        StackTraceElement[] theStackTrace = e.getStackTrace();
        for (int i = 0; i < theStackTrace.length; i++)
        {
            %><%=theStackTrace[i].toString()%><br><%
        }
    }    
}

}
catch (Exception e)
{
    %><hr><pre><%=e.toString()%></pre><%
    StackTraceElement[] theStackTrace = e.getStackTrace();
    for (int i = 0; i < theStackTrace.length; i++)
    {
        %><%=theStackTrace[i].toString()%><br><%
    }
}
%>
</bbData:context>

