<%@page import="java.util.*,
                java.text.*,
                java.io.*,
                java.net.URLEncoder,
                blackboard.base.*,
                blackboard.base.BbList,
                blackboard.data.*,
                blackboard.data.announcement.*,
                blackboard.data.calendar.*,
                blackboard.data.course.*,
                blackboard.data.task.*,
                blackboard.data.user.*,
                blackboard.persist.*,
                blackboard.persist.announcement.*,
                blackboard.persist.calendar.*,
                blackboard.persist.course.*,
                blackboard.persist.task.*,
                blackboard.persist.user.*,
                blackboard.platform.*,
                blackboard.platform.session.*,
                blackboard.portal.data.*, 
                blackboard.portal.servlet.*,
                wms.ss.data.*,
                wms.ss.db.*"
        errorPage="/error.jsp"
%><%@ taglib uri="/bbData" prefix="bbData"%>
<%@ taglib uri="/bbUI" prefix="bbUI"%><bbData:context id="ctx"><%
try
{
User curUser = ctx.getUser();
//String userPk = ctx.getUserId().toExternalString();
int userPkNum = DataUtil.getPkFromBbId(curUser.getId());// Integer.parseInt(userPk.substring(1,userPk.indexOf('_',1)));
String userName = curUser.getGivenName()+" "+curUser.getFamilyName();
String base_uri = blackboard.platform.plugin.PlugInUtil.getUriStem("wms", "wmss");
String frameworkIdStr = request.getParameter("frameworkId");
int frameworkId = Integer.parseInt(frameworkIdStr);
Framework curFramework = Framework.loadByFrameworkId(frameworkId);
String frameworkName = curFramework.getName();

String course_id = request.getParameter("course_id");

String errMsg = "";

/** parameters
 * onDay (YYYY/MM/DD)
 * startTimeHour (0-11)
 * startTimeMinute
 * startTimeAmPm
 * endTimeHour (0-11)
 * endTimeMinute
 * endTimeAmPm
 * numBlocksInTimeRange
 * repeatRate (1 (once only), 2 (days of week), or 3 (days of month))
 * dowSunday-Saturday
 * dom1-31
 * tilDay (YYYY/MM/DD)
 * numSLotsPerBlock
 */

// get vars of approp types from parameters
// * onDay (YYYY/MM/DD)
String s = request.getQueryString(); // appears unused...? Delete...?
String[] onDayStr = request.getParameter("onDay").split("/");
Calendar onDayCal = Calendar.getInstance();
onDayCal.clear();
onDayCal.set(Integer.parseInt(onDayStr[0]),Integer.parseInt(onDayStr[1])-1,Integer.parseInt(onDayStr[2]));
// * startTimeHour (0-11)
// * startTimeMinute
// * startTimeAmPm
int startTimeHour = Integer.parseInt(request.getParameter("startTimeHour"));
int startTimeMinute = Integer.parseInt(request.getParameter("startTimeMinute"));
if (request.getParameter("startTimeAmPm").equalsIgnoreCase("PM"))
{
    startTimeHour += 12;
}
// * endTimeHour (0-11)
// * endTimeMinute
// * endTimeAmPm
int endTimeHour = Integer.parseInt(request.getParameter("endTimeHour"));
int endTimeMinute = Integer.parseInt(request.getParameter("endTimeMinute"));
if (request.getParameter("endTimeAmPm").equalsIgnoreCase("PM"))
{
    endTimeHour += 12;
}
// * numBlocksInTimeRange
int numBlocksInTimeRange = Integer.parseInt(request.getParameter("numBlocksInTimeRange"));
// * repeatRate (1 (once only), 2 (days of week), or 3 (days of month))
int repeatRate = Integer.parseInt(request.getParameter("repeatRate"));
// * dowSunday-Saturday
String [] dayOfWeekNames = {"Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"};
ArrayList repeatOnDaysOfWeek = new ArrayList();
for (int dowIndex = 0; dowIndex < dayOfWeekNames.length; dowIndex++)
{
    if (request.getParameter("dow"+dayOfWeekNames[dowIndex]) != null)
    {
        repeatOnDaysOfWeek.add(dayOfWeekNames[dowIndex]);
    }
}
// * dom1-31
ArrayList repeatOnDaysOfMonth = new ArrayList();
for (int domIndex = 1; domIndex <= 31; domIndex++)
{
    String domStr = Integer.toString(domIndex);
    if (request.getParameter("dom"+domStr).equalsIgnoreCase("YES"))
    {
        repeatOnDaysOfMonth.add(domStr);
    }
}
// * tilDay (YYYY/MM/DD)
String theTilDay = request.getParameter("tilDay");
Calendar tilDayCal  = Calendar.getInstance();
if (repeatRate != 1)
{
    String[] tilDayStr = theTilDay.split("/");
    tilDayCal.set(Integer.parseInt(tilDayStr[0]),Integer.parseInt(tilDayStr[1])-1,Integer.parseInt(tilDayStr[2]));
}
// * numSlotsPerBlock
int numSlotsPerBlock = Integer.parseInt(request.getParameter("numSlotsPerBlock"));

// create basic block set for time range (this will be a Block[])
int timeRangeLengthMinutes = (endTimeHour - startTimeHour)*60;
if (endTimeMinute < startTimeMinute)
{
    timeRangeLengthMinutes -= 60;
    timeRangeLengthMinutes += (endTimeMinute + 60) - startTimeMinute;
} else {
    timeRangeLengthMinutes += endTimeMinute - startTimeMinute;
}
int blockLengthMinutes = timeRangeLengthMinutes/numBlocksInTimeRange;
Calendar startTime = Calendar.getInstance();
startTime.set(Calendar.HOUR_OF_DAY,startTimeHour);
startTime.set(Calendar.MINUTE,startTimeMinute);
Calendar endTime = Calendar.getInstance();
endTime.set(Calendar.HOUR_OF_DAY,endTimeHour);
endTime.set(Calendar.MINUTE,endTimeMinute);
Block[] baseBlockSet = new Block[numBlocksInTimeRange];
int blockSetId = SqlUtil.runSqlGetIntField("SELECT wms_ss_ids.nextval AS new_id FROM dual", "new_id");
for (int bbi = 0; bbi < baseBlockSet.length -1; bbi++)
{
    baseBlockSet[bbi] = new Block();
    baseBlockSet[bbi].setOwnerUserPk1(userPkNum); 
    baseBlockSet[bbi].setFrameworkId(frameworkId);
    baseBlockSet[bbi].setBlockSetId(blockSetId); 
    baseBlockSet[bbi].setStartDatetime(startTime.getTime());
    startTime.add(Calendar.MINUTE,blockLengthMinutes);
    baseBlockSet[bbi].setEndDatetime(startTime.getTime());
    baseBlockSet[bbi].setMaxSlots(numSlotsPerBlock);
}
// and the last one, which covers end of penultimate block to end of time range
int lastBbi = numBlocksInTimeRange - 1;
baseBlockSet[lastBbi] = new Block();
baseBlockSet[lastBbi].setOwnerUserPk1(userPkNum); 
baseBlockSet[lastBbi].setFrameworkId(frameworkId);
baseBlockSet[lastBbi].setBlockSetId(blockSetId); 
baseBlockSet[lastBbi].setStartDatetime(startTime.getTime());
baseBlockSet[lastBbi].setEndDatetime(endTime.getTime());
baseBlockSet[lastBbi].setMaxSlots(numSlotsPerBlock);

// on the start day (repeatRate==1)
// for each block in the set
//  set day as approp (possible to do this and leave the time alone? should be, though may need a little futzing)
//  check for existing block for this sheet for this time range, if so, add to errors and skip to next block
//  check for existing block for this sheet group for this time range, if so, add to errors
//  check for existing block for this owner for this time range, if so, add to errors
//  create block
// end for
if (repeatRate == 1)
{
    int year = onDayCal.get(Calendar.YEAR);
    int month = onDayCal.get(Calendar.MONTH);
    int day = onDayCal.get(Calendar.DAY_OF_MONTH);
    for (int bbi = 0; bbi < baseBlockSet.length; bbi++)
    {
        baseBlockSet[bbi].setStartDateOnly(year, month, day);
        baseBlockSet[bbi].setEndDateOnly(year, month, day);
        // need to check for conficts here! also approp error message stuff
        // giving up on in page conflict checking - created a conflict checker method on the Block object instead.
        if (baseBlockSet[bbi].hasTimeConflictInThisFramework())
        {
            errMsg = "One or more time blocks were not created because there are already blocks on this sheet that conflict with the times you gave.";
        }
        else
        {
            baseBlockSet[bbi].saveNew();
        }
    }
}

// if repeat rate == 2 and curDay.dayOfWeek in chosen dayOfWeek set
//  while curDay <= endDay
    // for each block in the set
    //  set day as approp (possible to do this and leave the time alone? should be, though may need a little futzing)
    //  check for existing block for this sheet for this time range, if so, add to errors and skip to next block
    //  check for existing block for this sheet group for this time range, if so, add to errors
    //  check for existing block for this owner for this time range, if so, add to errors
    //  create block
    // end for
//  end while
// cut & paste code re-use, oh well
if (repeatRate == 2)
{
    
    while (onDayCal.compareTo(tilDayCal)<0)
    {
        String onDayStrDayOfWeek = "";
        switch (onDayCal.get(Calendar.DAY_OF_WEEK))
        {
            case Calendar.SUNDAY :    onDayStrDayOfWeek = "Sunday"; break;
            case Calendar.MONDAY :    onDayStrDayOfWeek = "Monday"; break;
            case Calendar.TUESDAY :   onDayStrDayOfWeek = "Tuesday"; break;
            case Calendar.WEDNESDAY : onDayStrDayOfWeek = "Wednesday"; break;
            case Calendar.THURSDAY :  onDayStrDayOfWeek = "Thursday"; break;
            case Calendar.FRIDAY :    onDayStrDayOfWeek = "Friday"; break;
            case Calendar.SATURDAY :  onDayStrDayOfWeek = "Saturday"; break;
        }
        if (repeatOnDaysOfWeek.contains(onDayStrDayOfWeek))
        {
            int year = onDayCal.get(Calendar.YEAR);
            int month = onDayCal.get(Calendar.MONTH);
            int day = onDayCal.get(Calendar.DAY_OF_MONTH);
            for (int bbi = 0; bbi < baseBlockSet.length; bbi++)
            {
                baseBlockSet[bbi].setStartDateOnly(year, month, day);
                baseBlockSet[bbi].setEndDateOnly(year, month, day);
                // need to check for conficts here! also approp error message stuff
                // giving up on in page conflict checking - created a conflict checker method on the Block object instead.
                 if (baseBlockSet[bbi].hasTimeConflictInThisFramework())
                {
                    errMsg = "One or more time blocks were not created because there are already blocks on this sheet that conflict with the times you gave.";
                }
                else
                {
                    baseBlockSet[bbi].saveNew();
                }
            }
        }
        onDayCal.add(Calendar.DAY_OF_MONTH,1);
    }
}

// if repeat rate == 3 and curDay.dayOfMonth in chosen dayOfMonth set
//  while curDay <= endDay
    // for each block in the set
    //  set day as approp (possible to do this and leave the time alone? should be, though may need a little futzing)
    //  check for existing block for this sheet for this time range, if so, add to errors and skip to next block
    //  check for existing block for this sheet group for this time range, if so, add to errors
    //  check for existing block for this owner for this time range, if so, add to errors
    //  create block
    // end for
//  end while
// cut & paste code re-use, oh well
if (repeatRate == 3)
{
    while (onDayCal.compareTo(tilDayCal)<0)
    {
        String onDayStrDayOfMonth = Integer.toString(onDayCal.get(Calendar.DAY_OF_MONTH));
        if (repeatOnDaysOfMonth.contains(onDayStrDayOfMonth))
        {
            int year = onDayCal.get(Calendar.YEAR);
            int month = onDayCal.get(Calendar.MONTH);
            int day = onDayCal.get(Calendar.DAY_OF_MONTH);
            for (int bbi = 0; bbi < baseBlockSet.length; bbi++)
            {
                baseBlockSet[bbi].setStartDateOnly(year, month, day);
                baseBlockSet[bbi].setEndDateOnly(year, month, day);
                // need to check for conficts here! also approp error message stuff
                // giving up on in page conflict checking - created a conflict checker method on the Block object instead.
                if (baseBlockSet[bbi].hasTimeConflictInThisFramework())
                {
                    errMsg = "One or more time blocks were not created because there are already blocks on this sheet that conflict with the times you gave.";
                }
                else
                {
                    baseBlockSet[bbi].saveNew();
                }
            }
        }
        onDayCal.add(Calendar.DAY_OF_MONTH,1);
    }
}

// forward to ss_admin_mod_sheet_step2.jsp?frameworkId=frameworkId&errMsg=(encoded error message)
String redirectUrl = "ss_admin_mod_sheet_step2.jsp?frameworkId=" + Integer.toString(frameworkId) + ((course_id != null)?"&course_id="+course_id:"") + ((errMsg.length() > 0)?"&errorMessage="+ URLEncoder.encode(errMsg):"");
%><jsp:forward page="<%=redirectUrl%>" /><%

}
catch (Exception e)
{
    %><hr><pre><%=e.toString()%></pre><%
    StackTraceElement[] theStackTrace = e.getStackTrace();
    for (int i = 0; i < theStackTrace.length; i++)
    {
        %><%=theStackTrace[i].toString()%><br><%
    }
}
%>
</bbData:context>