<%@page import="java.util.*,
                java.text.*,
                java.io.*,
                blackboard.base.*,
                blackboard.base.BbList,
                blackboard.data.*,
                blackboard.data.announcement.*,
                blackboard.data.calendar.*,
                blackboard.data.course.*,
                blackboard.data.task.*,
                blackboard.data.user.*,
                blackboard.persist.*,
                blackboard.persist.announcement.*,
                blackboard.persist.calendar.*,
                blackboard.persist.course.*,
                blackboard.persist.task.*,
                blackboard.persist.user.*,
                blackboard.platform.*,
                blackboard.platform.session.*,
                blackboard.portal.data.*, 
                blackboard.portal.servlet.*,
                wms.ss.data.*,
                wms.ss.db.*"
        errorPage="/error.jsp"
%>
<%@ taglib uri="/bbData" prefix="bbData"%>
<%@ taglib uri="/bbUI" prefix="bbUI"%>

<bbData:context id="ctx">
<bbUI:docTemplate>
<%
User curUser = ctx.getUser();
int userPkNum = DataUtil.getPkFromBbId(ctx.getUserId()); 
String userName = curUser.getGivenName()+" "+curUser.getFamilyName();
String base_uri = blackboard.platform.plugin.PlugInUtil.getUriStem("wms", "wmss");

%>
<span style="font-size:16pt;">Sheet groups owned by <%=userName%>:</span>

<ul>
<%
SheetGroupList sgl = wms.ss.data.SheetGroupList.loadByOwnerUserId(userPkNum);
Iterator sgli = sgl.listIterator();

if (sgl.isEmpty())
{
    %><li>No sheet groups owned</li><%
}
else 
{
    while (sgli.hasNext())
    {
            SheetGroup sg = (SheetGroup)sgli.next();
            String sgName = sg.getName();
            int sheetGroupId = sg.getGroupId();
            %><li><a href="<%=base_uri%>groups/ss_admin_mod_group_step1.jsp?sheetGroupId=<%=sheetGroupId%>"><%=sgName%></a></li><%
    }
}
%>
</ul>

<br>
<hr>
<br>
<span style="font-size: 14pt;">
<span style="color: red;">Q</span>: 
What is a sheet group?<br>
<span style="color: green;">A</span>: 
A sheet group is a way to collect different sign up sheets together for 
organizational purposes and/or to establish signup limits across all sheets in 
a group. For example, if you wanted to be able to find quickly all
your office hours sheets but wanted different courses to have different 
office hours, you could create an office hours group and then put all those 
sheets in that group. As another example, if you're running a series of five
labs and you want your users to sign up for at most two of them, you could 
create a Labs sheet group with max signup limit of two, and then each of the
five lab sign up sheets would be in that group (and you'd set the limits on 
those individual sheets to one, so a user couldn't signup for the same lab
more than once).
<br><br>
<span style="color: red;">Q</span>: Do I really need to worry about sheet groups?<br>
<span style="color: green;">A</span>: Nope. You always have a default sheet group, which is automatically 
created for you the first time you create a sheet and into which are 
placed new sheets that you create. You can safely ignore groups if you 
don't want to deal with them.
</span>

</bbUI:docTemplate>
</bbData:context>

