<%@page import="java.util.*,
                java.text.*,
                java.io.*,
                blackboard.base.*,
                blackboard.base.BbList,
                blackboard.data.*,
                blackboard.data.announcement.*,
                blackboard.data.calendar.*,
                blackboard.data.course.*,
                blackboard.data.task.*,
                blackboard.data.user.*,
                blackboard.persist.*,
                blackboard.persist.announcement.*,
                blackboard.persist.calendar.*,
                blackboard.persist.course.*,
                blackboard.persist.task.*,
                blackboard.persist.user.*,
                blackboard.platform.*,
                blackboard.platform.session.*,
                blackboard.portal.data.*, 
                blackboard.portal.servlet.*,
                wms.ss.data.*,
                wms.ss.db.*"
        errorPage="/error.jsp"
%><%@ taglib uri="/bbData" prefix="bbData"%>
<%@ taglib uri="/bbUI" prefix="bbUI"%><bbData:context id="ctx"><%
/* NOTE: as of 2006/06/12 this functionality has been removed from the signup 
 * sheets. This was due to a combination of things. First, a bug was discovered
 * in the multidelete code (details as yet unknown) by someone (mis)using the 
 * too. Second, no one actually had any reason to use the tool - the only times 
 * it was used, it was misused (i.e. attempting to delete a single block). As
 * such, the tool was removed rather than fixed, but the structure is left 
 * around in case we want to re-introduce it later.
 */ 

User curUser = ctx.getUser();
//String userPk = ctx.getUserId().toExternalString();
int userPkNum = DataUtil.getPkFromBbId(curUser.getId());// Integer.parseInt(userPk.substring(1,userPk.indexOf('_',1)));
String userName = curUser.getGivenName()+" "+curUser.getFamilyName();
String base_uri = blackboard.platform.plugin.PlugInUtil.getUriStem("wms", "wmss");

String frameworkIdStr = request.getParameter("frameworkId");
int frameworkId = Integer.parseInt(frameworkIdStr);
Framework curFramework = Framework.loadByFrameworkId(frameworkId);
String frameworkName = curFramework.getName();

String course_id = request.getParameter("course_id");

/** parameters
 * multiDeleteStartDate (YYYY/MM/DD)
 * multiDeleteEndDate (YYYY/MM/DD)
 * startTimeHour (0-11)
 * startTimeMinute
 * startTimeAmPm
 * endTimeHour (0-11)
 * endTimeMinute
 * endTimeAmPm
 */

int startTimeHour = Integer.parseInt(request.getParameter("startTimeHour"));
int startTimeMinute = Integer.parseInt(request.getParameter("startTimeMinute"));
if (request.getParameter("startTimeAmPm").equalsIgnoreCase("PM"))
{
    startTimeHour += 12;
}
String[] multiDeleteStartDateStr = request.getParameter("multiDeleteStartDate").split("/");
Calendar multiDeleteStartDateCal = Calendar.getInstance();
multiDeleteStartDateCal.clear();
multiDeleteStartDateCal.set(
        Integer.parseInt(multiDeleteStartDateStr[0]),
        Integer.parseInt(multiDeleteStartDateStr[1])-1,
        Integer.parseInt(multiDeleteStartDateStr[2]),
        startTimeHour,
        startTimeMinute);

// * multiDeleteEndDate (YYYY/MM/DD)
int endTimeHour = Integer.parseInt(request.getParameter("endTimeHour"));
int endTimeMinute = Integer.parseInt(request.getParameter("endTimeMinute"));
if (request.getParameter("endTimeAmPm").equalsIgnoreCase("PM"))
{
    endTimeHour += 12;
}
String[] multiDeleteEndDateStr = request.getParameter("multiDeleteEndDate").split("/");
Calendar multiDeleteEndDateCal = Calendar.getInstance();
multiDeleteEndDateCal.clear();
multiDeleteEndDateCal.set(
        Integer.parseInt(multiDeleteEndDateStr[0]),
        Integer.parseInt(multiDeleteEndDateStr[1]),
        Integer.parseInt(multiDeleteEndDateStr[2]),
        endTimeHour,
        endTimeMinute);

BlockList toDelete = BlockList.loadByFrameworkId(frameworkId,multiDeleteStartDateCal.getTime(),multiDeleteEndDateCal.getTime());

for (int toDeleteIndex = 0; toDeleteIndex < toDelete.size(); toDeleteIndex++)
{
    Block blockToDelete = (Block)toDelete.get(toDeleteIndex);
    Block.deleteByBlockId(blockToDelete.getBlockId());
}

String redirectUrl = "ss_admin_mod_sheet_step2.jsp?frameworkId=" + frameworkIdStr + ((course_id != null)?"&course_id="+course_id:"");
%><jsp:forward page="<%= redirectUrl %>" />

</bbData:context>

