<%@page import="java.util.*,
                java.text.*,
                java.io.*,
                java.sql.*,
                blackboard.base.*,
                blackboard.base.BbList,
                blackboard.data.*,
                blackboard.data.announcement.*,
                blackboard.data.calendar.*,
                blackboard.data.course.*,
                blackboard.data.task.*,
                blackboard.data.user.*,
                blackboard.db.*,
                blackboard.persist.*,
                blackboard.persist.announcement.*,
                blackboard.persist.calendar.*,
                blackboard.persist.course.*,
                blackboard.persist.Id.*,
                blackboard.persist.PkId.*,
                blackboard.persist.task.*,
                blackboard.persist.user.*,
                blackboard.platform.*,
                blackboard.platform.session.*,
                blackboard.portal.data.*, 
                blackboard.portal.servlet.*,
                wms.ss.data.*,
                wms.ss.display.*,
                wms.ss.db.*"
        errorPage="/error.jsp"
%>
<%@ taglib uri="/bbData" prefix="bbData"%>
<%@ taglib uri="/bbUI" prefix="bbUI"%>

<bbData:context id="ctx">
<bbUI:docTemplate>

<script language="javascript">
document.writeln('<style type="text/css" media="all">');
document.writeln('@import "showBlock.css";');
document.writeln('</style>');
document.writeln('<style type="text/css" media="print">');
document.writeln('@import "printBlock.css";');
document.writeln('</style>');
</script>

<%
try
{
User curUser = ctx.getUser();
int userPkNum = DataUtil.getPkFromBbId(curUser.getId());
String userName = curUser.getGivenName()+" "+curUser.getFamilyName();
String base_uri = blackboard.platform.plugin.PlugInUtil.getUriStem("wms", "wmss");
String errMsg = request.getParameter("errorMessage");
errMsg = (errMsg == null)?"":errMsg;

String course_id = request.getParameter("course_id");

String saveActionButtonName = "saveBlockButton";
String saveActionButtonText = "Save this block";
String theActionMessageSave = "Saved";
String theActionMessageSend = "Sent";

String frameworkIdStr = request.getParameter("frameworkId");
int frameworkId = Integer.parseInt(frameworkIdStr);
Framework curFramework = Framework.loadByFrameworkId(frameworkId);
String previousAction = request.getParameter(saveActionButtonName);
previousAction = (previousAction == null)?"":previousAction;
String unknownsList = "";

String blockIdStr = request.getParameter("blockId");
int blockId = Integer.parseInt(blockIdStr);
Block curBlock = Block.loadByBlockId(blockId);
curBlock.computeBlockUsage();

String actionMessageSend = request.getParameter("actionMessageSend");
if ((actionMessageSend != null) && (actionMessageSend.equalsIgnoreCase(theActionMessageSend)) && (errMsg.length() < 1))
{
    String emailSubject = request.getParameter("emailSubject") + " : "+curFramework.getName()+" "+curBlock.getBlockDateStr()+" signup";
    String emailMessage = "RE: "+curFramework.getName()+" "+curBlock.getBlockDateStr()+" "+curBlock.getBlockTimingStr()+" signup \n\n "+request.getParameter("emailMessage");
    curBlock.sendEmailToSignees(emailSubject,emailMessage);
    curBlock.sendEmailToOwner(emailSubject+" - CONFIRMATION",emailMessage);
}

String actionMessageSave = request.getParameter("actionMessageSave");
int startTimeHour, startTimeMinute, endTimeHour, endTimeMinute, maxSlots;
String startTimeAmPm, endTimeAmPm;
if ((actionMessageSave != null) && (actionMessageSave.equalsIgnoreCase(theActionMessageSave)) && (errMsg.length() < 1))
{
    // startTime and EndTime
    startTimeHour = Integer.parseInt(request.getParameter("startTimeHour"));
    startTimeMinute = Integer.parseInt(request.getParameter("startTimeMinute"));
    if (request.getParameter("startTimeAmPm").equalsIgnoreCase("PM"))
    {
        startTimeHour += 12;
        startTimeAmPm = "PM";
    }
    else
    {
        startTimeAmPm = "AM";
    }
    // * endTimeHour (0-11)
    // * endTimeMinute
    // * endTimeAmPm
    endTimeHour = Integer.parseInt(request.getParameter("endTimeHour"));
    endTimeMinute = Integer.parseInt(request.getParameter("endTimeMinute"));
    if (request.getParameter("endTimeAmPm").equalsIgnoreCase("PM"))
    {
        endTimeHour += 12;
        endTimeAmPm = "PM";
    }
    else
    {
        endTimeAmPm = "AM";
    }
    // maxSlots
    maxSlots = Integer.parseInt(request.getParameter("maxSlots"));
    
    // now do the save
    Calendar startTime = Calendar.getInstance();
    startTime.setTime(curBlock.getStartDatetime());
    startTime.set(Calendar.HOUR_OF_DAY,startTimeHour);
    startTime.set(Calendar.MINUTE,startTimeMinute);
    Calendar endTime = Calendar.getInstance();
    endTime.setTime(curBlock.getEndDatetime());
    endTime.set(Calendar.HOUR_OF_DAY,endTimeHour);
    endTime.set(Calendar.MINUTE,endTimeMinute);
    
    curBlock.setStartDatetime(startTime.getTime());
    curBlock.setEndDatetime(endTime.getTime());
    curBlock.setMaxSlots(maxSlots);
    curBlock.setAdminComment(request.getParameter("admin_comment"));
    curBlock.save();
    
    // now do the save for each slot for which it's necessary
    // 1. get all the slots for this block
    // 2. for each one
    // 3.a. compare admin comment in list to admin comment parameter
    // 3.b. if different
    // 4.a. set slot signup updated by
    // 4.b. set slot signup admin comment
    // 4.c. save the slot
    SlotSignupList slots = SlotSignupList.loadByBlockId(curBlock.getBlockId());
    for (int slotIndex = 0; slotIndex < slots.size(); slotIndex++)
    {
        SlotSignup curSlot = (SlotSignup)slots.get(slotIndex);
        String paramComment = request.getParameter("ss_admin_comment_"+Integer.toString(curSlot.getSlotSignupId()));
        if ((paramComment != null) && (! (paramComment.equals(curSlot.getAdminComment()))))
        {
            curSlot.setAdminComment(paramComment);
            curSlot.setUpdatedByUserPk1(userPkNum);
            curSlot.save();
        }
    }
}

Calendar cal = Calendar.getInstance();
cal.setTime(curBlock.getStartDatetime());
startTimeHour = cal.get(Calendar.HOUR);
startTimeMinute = cal.get(Calendar.MINUTE);
startTimeAmPm = (cal.get(Calendar.AM_PM)==Calendar.AM)?"AM":"PM";


cal.setTime(curBlock.getEndDatetime());
endTimeHour = cal.get(Calendar.HOUR);
endTimeMinute = cal.get(Calendar.MINUTE);
endTimeAmPm = (cal.get(Calendar.AM_PM)==Calendar.AM)?"AM":"PM";

maxSlots = curBlock.getMaxSlots();

HtmlCalendarTool hct = new HtmlCalendarTool();
String dayOfBlock = hct.downToDayDateFormatter.format(curBlock.getStartDatetime());
String timing = hct.hourMinFormatter.format(curBlock.getStartDatetime()) + "-" + 
        hct.hourMinAmPmFormatter.format(curBlock.getEndDatetime());
String maxSlotsText = (maxSlots<0)?"*":Integer.toString(maxSlots);

if (course_id != null)
{
%>
<bbUI:breadcrumbBar handle="course_tools_area">
    <bbUI:breadcrumb href="<%=base_uri + "ss_admin_class.jsp?course_id="+course_id%>">Signup Sheets</bbUI:breadcrumb>
    <bbUI:breadcrumb href="<%=base_uri + "ss_admin_mod_sheet_step2.jsp?course_id="+course_id+"&frameworkId="+frameworkIdStr%>"><%=curFramework.getName()%></bbUI:breadcrumb>
    <bbUI:breadcrumb><%=dayOfBlock%> <%=timing%></bbUI:breadcrumb>
</bbUI:breadcrumbBar>
<%
}
%>

<table>
 <tr>
  <td>
<%
if (actionMessageSave != null)
{
    %><span class="hideForPrinting" style="font-size:16pt; font-weight: bold; font-family: arial, sans-serif; color: green;"><%=actionMessageSave%></span><%
}
if (actionMessageSend != null)
{
    %><span class="hideForPrinting" style="font-size:16pt; font-weight: bold; font-family: arial, sans-serif; color: green;"><%=actionMessageSend%></span><%
}
%>

<span style="float:left; font-size:16pt; font-weight:bold;">Information for <a href="ss_admin_mod_sheet_step2.jsp?frameworkId=<%=frameworkIdStr%>&blockId=<%=blockIdStr%><%=(course_id != null)?"&course_id="+course_id:""%>"><%=curFramework.getName()%> <%=dayOfBlock%> <%=timing%></a></span>

<br clear="all">
<form class="hideForPrinting" style="float:right;" method="GET" action="ss_admin_mod_block.jsp" target="_new">
<input type="hidden" name="frameworkId" value="<%=frameworkIdStr%>">
<input type="hidden" name="blockId" value="<%=blockIdStr%>">
<%
if (course_id != null)
{
    %><input type="hidden" name="course_id" value="<%=course_id%>"><%
}
%>
<input type="submit" name="printableSubmit" value="Printable Version (opens in new window)">
</form>
<br clear="all">

<div class="hideForPrinting">
<form action="ss_admin_mod_block.jsp" method="GET">
<input type="hidden" name="frameworkId" value="<%=frameworkIdStr%>">
<input type="hidden" name="blockId" value="<%=blockIdStr%>">
<input type="hidden" name="actionMessageSave" value="<%=theActionMessageSave%>">
<%
if (course_id != null)
{
    %><input type="hidden" name="course_id" value="<%=course_id%>"><%
}
%>
<table>

 <tr>
  <td align="right" width="20%">Starts at:</td>
  <td align="left">
<select id="IDstartTimeHour" name="startTimeHour">
<%
for (int i=0; i <= 11; i++)
{
    %><option value="<%=i%>" <%=(i==startTimeHour)?"selected":""%>><%=(i==0)?"12":Integer.toString(i)%></option>
<%
}
%>
</select>:<select id="IDstartTimeMinute" name="startTimeMinute">
<%
for (int i=0; i < 60; i+=5)
{
    %><option value="<%=i%>" <%=(i==startTimeMinute)?"selected":""%>><%=((i<10)?"0":"")+Integer.toString(i)%></option>
<%
}
%>
</select> <select id="IDstartTimeAmPm" name="startTimeAmPm">
<option value="am" <%=(startTimeAmPm.equals("AM"))?"selected":""%>>AM</option>
<option value="pm" <%=(startTimeAmPm.equals("PM"))?"selected":""%>>PM</option>
</select>
  </td>
 </tr>

 <tr>
  <td align="right">Ends at:</td>
  <td align="left">
<select id="IDendTimeHour" name="endTimeHour">
<%
for (int i=0; i <= 11; i++)
{
    %><option value="<%=i%>" <%=(i==endTimeHour)?"selected":""%>><%=(i==0)?"12":Integer.toString(i)%></option>
<%
}
%>
</select>:<select id="IDendTimeMinute" name="endTimeMinute">
<%
for (int i=0; i < 60; i+=5)
{
    %><option value="<%=i%>" <%=(i==endTimeMinute)?"selected":""%>><%=((i<10)?"0":"")+Integer.toString(i)%></option>
<%
}
%>
</select> <select id="IDendTimeAmPm" name="endTimeAmPm">
<option value="am" <%=(endTimeAmPm.equals("AM"))?"selected":""%>>AM</option>
<option value="pm" <%=(endTimeAmPm.equals("PM"))?"selected":""%>>PM</option>
</select>
  </td>
 </tr>
 
 <tr>
  <td align="right">Maximum signups:</td>
  <td align="left">
    <select name="maxSlots">
        <option value="-1"<%=(maxSlots==-1?" selected":"")%>>Unlimited</option>
<%
    for (int limitNum = 1; limitNum <= 120; limitNum++)
    {
        ;%><option value="<%=limitNum%>"<%=(maxSlots==limitNum?" selected":"")%>><%=limitNum%></option><%
    }
%>
    </select> This is the upper limit of the total number of people that may sign up for this block on this sheet.
  </td>
 </tr>
 
 <tr>
  <td align="right" valign="top">Note/Comment:<br><span style="font-size: 8pt;">(this appears in alert emails along with the sheet description; usually used for specifying location, or discussion topic, or pre-reading, etc.)</span></td>
  <td align="left">
<textarea name="admin_comment" rows="4" cols="80"><%=curBlock.getAdminComment()%></textarea>
  </td>
 </tr>

</table>

<br>
<center><input style="background-color:#99DD99; font-size:16pt;" type="submit" name="<%=saveActionButtonName%>" value="<%=saveActionButtonText%>"></center>

<hr>

<span style="float:left; font-size:16pt; font-weight:bold;">Signups</span>

</div> <!-- end the form stuff -->

<div class="showForPrinting">
<font size="+1"><%=curBlock.getAdminComment()%></font>
</div>

<!-- list here the signups for this block -->
<%
if (curBlock.getUsedSlots() > 0)
{
    SlotSignupList ssl = SlotSignupList.loadByBlockId(blockId);
    %>
<blockquote>
There <%=(curBlock.getUsedSlots()==1)?"is":"are"%> <%=Integer.toString(curBlock.getUsedSlots())%> signup<%=(curBlock.getUsedSlots()==1)?"":"s"%> in this block.
</blockquote>

<table>
 <tr>
  <td width="250" style="text-align: left; font-family: arial, sans-serif; font-size:12pt; font-weight: bold; border-bottom: 1px solid black;">Name</td>
  <td width="200" style="text-align: left; font-family: arial, serif; font-size:12pt; font-weight: bold; border-bottom: 1px solid black;">User Id</td>
  <td width="40" style="text-align: left; font-family: arial, sans-serif; font-size:10pt; border-bottom: 1px solid black;"><div id="theDeleteStuff">delete</div><div id="theAttendanceStuff">present?</div></td>
  <td width="80" style="text-align: left; font-family: arial, sans-serif; font-size:10pt; border-bottom: 1px solid black;"><div id="theDeleteStuff">comments</div></td>
 </tr>    
<%
        for (int ssIndex = 0; ssIndex < ssl.size(); ssIndex++)
        {
            SlotSignup ss = (SlotSignup)ssl.get(ssIndex);            
            %> <tr>
  <td style="text-align: left; font-family: arial, sans-serif; font-size:12pt;"><%=ss.getUserFirstName()%> <%=ss.getUserLastName()%> </td>
  <td style="text-align: left; font-family: courier, serif; font-size:12pt;"><%=ss.getUserId()%></td>
  <td id="attendanceBox" style="text-align: left; font-family: arial, sans-serif; font-size:12pt;">
<div id="theDeleteStuff">(<a title="Delete this signup" style="color:#CC6633;" href="<%=base_uri%>slot_signups/ss_admin_del_signup.jsp?slotSignupId=<%=ss.getSlotSignupId()%>&blockId=<%=curBlock.getBlockId()%>&frameworkId=<%=frameworkId%>"   onclick="return confirm('You are about to delete the signup. Click OK to do so, and Cancel to abort.')"><b>X</b></a>)</div>
<div id="theAttendanceStuff">&nbsp;</div></td>
  <td style="text-align: left; font-family: arial, sans-serif; font-size:12pt;">
<div id="comment_text"><span style="font-family: arial, sans-serif; font-size:8pt;"><%=ss.getAdminComment()%></span></div>
<div id="comment_box"><input type="text" name="ss_admin_comment_<%=ss.getSlotSignupId()%>" value="<%=ss.getAdminComment()%>" size="40" maxlength="511"></div>
  </td>
 </tr>
<%
        }
        %></table>
<%
}        
else // usage <= 1
{
    %>There are no signups in this block.<%
}


%>
</form> <!-- end save form -->
<%
if (curBlock.getUsedSlots() > 0)
{
%>
<p>
<hr>
<p>
<div class="hideForPrinting" style="border:solid blue 2px;">
<form  action="ss_admin_mod_block.jsp" method="GET">
<input type="hidden" name="frameworkId" value="<%=frameworkIdStr%>">
<input type="hidden" name="blockId" value="<%=blockIdStr%>">
<input type="hidden" name="actionMessageSend" value="<%=theActionMessageSend%>">
<%
    if (course_id != null)
    {
        %><input type="hidden" name="course_id" value="<%=course_id%>"><%
    }
    %>
<center><span style="font-size:16pt; font-weight: bold;">Send an email to everyone signed up for this time block:</span></center>
<table>
    <tr><td align="right" valign="top">Subject:</td>
        <td align="left" valign="top"><input type="text" name="emailSubject" value="" size="32" maxlength="64"></td></tr>
    <tr><td align="right" valign="top">Message:</td>
        <td align="left" valign="top"><textarea name="emailMessage" rows="4" cols="80" wrap="soft"></textarea></td></tr>
</table>
<center><input type="submit" name="emailSubmit" value="Send it"></center>
</form>
</div>
<%
}
%>
  
  </td>
 </tr>
</table>

<%
}
catch (Exception e)
{
    %><hr><pre><%=e.toString()%></pre><%
    StackTraceElement[] theStackTrace = e.getStackTrace();
    for (int i = 0; i < theStackTrace.length; i++)
    {
        %><%=theStackTrace[i].toString()%><br><%
    }
}
%>

</bbUI:docTemplate>
</bbData:context>

