<%@page import="java.util.*,
                java.text.*,
                java.io.*,
                blackboard.base.*,
                blackboard.base.BbList,
                blackboard.data.*,
                blackboard.data.announcement.*,
                blackboard.data.calendar.*,
                blackboard.data.course.*,
                blackboard.data.task.*,
                blackboard.data.user.*,
                blackboard.persist.*,
                blackboard.persist.announcement.*,
                blackboard.persist.calendar.*,
                blackboard.persist.course.*,
                blackboard.persist.task.*,
                blackboard.persist.user.*,
                blackboard.platform.*,
                blackboard.platform.session.*,
                blackboard.portal.data.*, 
                blackboard.portal.servlet.*,
                wms.ss.data.*,
                wms.ss.db.*"
        errorPage="/error.jsp"
%>
<%@ taglib uri="/bbData" prefix="bbData"%>
<%@ taglib uri="/bbUI" prefix="bbUI"%>

<bbData:context id="ctx">
<bbUI:docTemplate>
<%
try
{
User curUser = ctx.getUser();
int userPkNum = DataUtil.getPkFromBbId(ctx.getUserId()); 
String userName = curUser.getGivenName()+" "+curUser.getFamilyName();
String base_uri = blackboard.platform.plugin.PlugInUtil.getUriStem("wms", "wmss");
%>

<span style="font-size:16pt;">Signup sheets administered by <%=userName%>:</span>
<ul>
<%
FrameworkList fl = wms.ss.data.FrameworkList.loadByAdminUserId(userPkNum);
Iterator fli = fl.listIterator();

if (fl.isEmpty())
{
    %><li>No signup sheets owned</li><%
}
else 
{
    while (fli.hasNext())
    {
            Framework f = (Framework)fli.next();
            String fName = f.getName();
            int frameworkId = f.getFrameworkId();
            String ownsFramework = "";
            String italicsOpen = "";
            String italicsClose = "";
            if (f.getOwnerUserPk1()!=userPkNum) 
            {
                ownsFramework=" (owned by "+f.getOwnerName()+", you have Admin privileges)";
                italicsOpen = "<i>";
                italicsClose = "</i>";
            }
            %><li><%=italicsOpen%><a href="<%=base_uri%>sheets/ss_admin_mod_sheet_step1.jsp?frameworkId=<%=frameworkId%>"><%=fName%></a><%=ownsFramework%><%=italicsClose%></li><%
    }
}
%>
</ul>

<hr>

<a href="<%=base_uri%>sheets/ss_admin_cr_sheet_step1.jsp">Create a new Signup Sheet</a>
<%
}
catch (Exception e)
{
    %><hr><pre><%=e.toString()%></pre><%
    StackTraceElement[] theStackTrace = e.getStackTrace();
    for (int i = 0; i < theStackTrace.length; i++)
    {
        %><%=theStackTrace[i].toString()%><br><%
    }
}
%>

</bbUI:docTemplate>
</bbData:context>

