<%@page import="java.util.*,
                java.text.*,
                java.io.*,
                blackboard.base.*,
                blackboard.base.BbList,
                blackboard.data.*,
                blackboard.data.announcement.*,
                blackboard.data.calendar.*,
                blackboard.data.course.*,
                blackboard.data.task.*,
                blackboard.data.user.*,
                blackboard.persist.*,
                blackboard.persist.announcement.*,
                blackboard.persist.calendar.*,
                blackboard.persist.course.*,
                blackboard.persist.task.*,
                blackboard.persist.user.*,
                blackboard.platform.*,
                blackboard.platform.session.*,
                blackboard.portal.data.*, 
                blackboard.portal.servlet.*,
                wms.email.*,
                wms.ss.data.*,
                wms.ss.db.*,
                wms.ss.display.*"
        errorPage="/error.jsp"
%><%@ taglib uri="/bbData" prefix="bbData"%><%@ taglib uri="/bbUI" prefix="bbUI"%><bbData:context id="ctx"><%
try
{
User curUser = ctx.getUser();
int userPkNum = DataUtil.getPkFromBbId(curUser.getId());
String userName = curUser.getGivenName()+" "+curUser.getFamilyName();
String base_uri = blackboard.platform.plugin.PlugInUtil.getUriStem("wms", "wmss");
String errMsg = request.getParameter("errorMessage");
errMsg = (errMsg == null)?"":errMsg;
Calendar cal = Calendar.getInstance();
java.util.Date rightNow = cal.getTime();

String coursePkStr = request.getParameter("coursePk");
int coursePkNum = 0;
if (coursePkStr != null)
{
    coursePkNum = Integer.parseInt(coursePkStr);
}

String frameworkIdStr = request.getParameter("frameworkId");
if (frameworkIdStr == null)
{
    %>
<bbUI:docTemplate>
<span style="font-size:16pt;">Sign up for a slot on which sheet?</span><br>
<%
    FrameworkList fl = null;
    if (coursePkNum != 0)
    {
        fl = wms.ss.data.FrameworkList.loadByCourseId(coursePkNum);
    }
    else
    {
        fl = wms.ss.data.FrameworkList.loadByAccessUserId(userPkNum);
    }
    Iterator fli = fl.listIterator();

    if (fl.isEmpty())
    {
        %>No sheets available.<%
    }
    else 
    {
        %><table>
<%
        while (fli.hasNext())
        {
            %><tr><%
            Framework f = (Framework)fli.next();
            if (1==0) {%>[<%=f.getFrameworkId()%>]<%} // debugging
            // find out if the framework has any open signup slots, and if not then don't display it, or display with an appropriate message
            String frameworkMessage = "";
            if (f.getNumberOfBlocks() < 1)
            {
                frameworkMessage = "This sheet has no blocks defined.<br>\n";
            }
            else if (f.getNumberOfOpenBlocks() < 1)
            {
                frameworkMessage = "This sheet has no open space.<br>\n";
            } else {
                SheetGroup group = SheetGroup.loadByFrameworkId(f.getFrameworkId());
                int frameworkTotalUsage = f.usageTotalByUser(userPkNum);
                int frameworkPendingUsage = f.usageByUserByTimeRange(userPkNum,rightNow,null);
                int groupTotalUsage = group.usageTotalByUser(userPkNum);
                int groupPendingUsage = group.usageByUserByTimeRange(userPkNum,rightNow,null);
                java.util.Date signupDeadline = f.getSignupDeadline();
                if ((f.getMaxTotalSlotsPerUser() >= 0) && (frameworkTotalUsage >= f.getMaxTotalSlotsPerUser()))
                {
                    frameworkMessage = frameworkMessage + "Your total signups ("+Integer.toString(frameworkTotalUsage)+") meet or exceed the sheet limits("+Integer.toString(f.getMaxTotalSlotsPerUser())+").<br>\n";
                } 
                if ((f.getMaxPendingSlotsPerUser() >= 0) && (frameworkPendingUsage >= f.getMaxPendingSlotsPerUser()))
                {
                    frameworkMessage = frameworkMessage + "Your pending signups ("+Integer.toString(frameworkPendingUsage)+") meet or exceed the sheet limits("+Integer.toString(f.getMaxPendingSlotsPerUser())+").<br>\n";
                } 
                if ((group.getMaxTotalSlotsPerUser() >= 0) && (groupTotalUsage >= group.getMaxTotalSlotsPerUser()))
                {
                    frameworkMessage = frameworkMessage + "Your total signups in the group ("+Integer.toString(groupTotalUsage)+") meet or exceed the group limits("+Integer.toString(group.getMaxTotalSlotsPerUser())+").<br>\n";
                } 
                if ((group.getMaxPendingSlotsPerUser() >= 0) && (groupPendingUsage >= group.getMaxPendingSlotsPerUser()))
                {
                    frameworkMessage = frameworkMessage + "Your pending signups in the group ("+Integer.toString(groupPendingUsage)+") meet or exceed the group limits("+Integer.toString(group.getMaxPendingSlotsPerUser())+").<br>\n";
                } 
                if ((signupDeadline != null) && (rightNow.after(signupDeadline)))
                {
                    frameworkMessage = frameworkMessage + "The signup deadline for this sheet ("+HtmlCalendarTool.downToDayDateFormatter.format(signupDeadline)+") has passed.<br>\n";
                }
            }

            String fName = f.getName();
            if (frameworkMessage.equals(""))
            {
                int frameworkId = f.getFrameworkId();
                %><td valign="top" align="right"><a href="<%=base_uri%>sheets/ss_user_vw_sheet_step1.jsp?frameworkId=<%=frameworkId%><%=(coursePkStr != null)?"&course_id="+coursePkStr:""%>"><%=fName%></a><br></td><td></td><%
            }
            else
            {
                %><td valign="top" align="right"><%=fName%><br></td><td valign="top" align="left"><span style="color: red; font-weight: bold;"><%=frameworkMessage%></span></td><%
            }
            %></tr>
<%
        } // end while
        %></table>
<%
    }
%>
</bbUI:docTemplate>
<%
}
int frameworkId = Integer.parseInt(frameworkIdStr);
Framework curFramework = Framework.loadByFrameworkId(frameworkId);
String frameworkName = curFramework.getName();
String redirectUrl = "../sheets/ss_user_vw_sheet_step1.jsp?frameworkId=" + frameworkIdStr + ((coursePkStr != null)?"&course_id="+coursePkStr:"");

String blockIdStr = request.getParameter("blockId");
if (blockIdStr == null)
{
    // forward to the block display for that framework
    %><jsp:forward page="<%= redirectUrl %>" /><%
}
int blockId = Integer.parseInt(blockIdStr);

// at this point, have frameworkID, blockID, and userPkNum
// create the sslotsignup, then forward to sheet block display with the given block highlighted
SlotSignup ss = new SlotSignup();
ss.setBlockId(blockId);
ss.setUpdatedByUserPk1(userPkNum);
ss.setUserPk1(userPkNum);
ss.saveNew();
ss = SlotSignup.loadBySlotSignupId(ss.getSlotSignupId()); // this fills out all the aux info, like the username etc.
ss.emailAddAlertToBlockOwner();

redirectUrl = "../sheets/ss_user_vw_sheet_step1.jsp?frameworkId=" + frameworkIdStr + "&blockId=" + blockIdStr + ((coursePkStr != null)?"&course_id="+coursePkStr:"");
%><jsp:forward page="<%= redirectUrl %>" />

<%
}
catch (Exception e)
{
    %><hr><pre><%=e.toString()%></pre><%
    StackTraceElement[] theStackTrace = e.getStackTrace();
    for (int i = 0; i < theStackTrace.length; i++)
    {
        %><%=theStackTrace[i].toString()%><br><%
    }
}
%>
</bbData:context>

