<%@page import="java.util.*,
                java.text.*,
                java.io.*,
                java.sql.*,
                blackboard.base.*,
                blackboard.base.BbList,
                blackboard.data.*,
                blackboard.data.announcement.*,
                blackboard.data.calendar.*,
                blackboard.data.course.*,
                blackboard.data.task.*,
                blackboard.data.user.*,
                blackboard.db.*,
                blackboard.persist.*,
                blackboard.persist.announcement.*,
                blackboard.persist.calendar.*,
                blackboard.persist.course.*,
                blackboard.persist.Id.*,
                blackboard.persist.PkId.*,
                blackboard.persist.task.*,
                blackboard.persist.user.*,
                blackboard.platform.*,
                blackboard.platform.session.*,
                blackboard.portal.data.*, 
                blackboard.portal.servlet.*,
                wms.ss.data.*,
                wms.ss.data.DataUtil,
                wms.ss.db.*,
                wms.ss.display.*"
        errorPage="/error.jsp"
%>
<%@ taglib uri="/bbData" prefix="bbData"%>
<%@ taglib uri="/bbUI" prefix="bbUI"%>
<!-- 1 -->
<bbData:context id="ctx">
<!-- 2 -->
<link type="text/css" rel="stylesheet" href="datetimepicker_style.css"/>
<bbUI:docTemplate>
<!-- 3 -->

<script language="javascript" type="text/javascript" src="datetimepicker.js">
</script>

<script language="javascript" type="text/javascript">
var allowDirectDateEdit=false;
</script>

<% 
boolean debugx = false;
boolean debugb = false;
boolean debugalpha = false;
%>
<%
try
{
if (debugx) {%>x1<%}
User curUser = ctx.getUser();
if (debugx) {%>x2<%}
int userPkNum = DataUtil.getPkFromBbId(curUser.getId());
if (debugx) {%>x3<%}
String userName = curUser.getGivenName()+" "+curUser.getFamilyName();
if (debugx) {%>x4<%}
String base_uri = blackboard.platform.plugin.PlugInUtil.getUriStem("wms", "wmss");
if (debugx) {%>x5<%}
String errMsg = request.getParameter("errorMessage");
if (debugx) {%>x6<%}
errMsg = (errMsg == null)?"":errMsg;
if (debugx) {%>x7<%}

String course_id = request.getParameter("course_id");
if (debugx) {%>x8<%}
String actionMessage = request.getParameter("actionMessage");
if (debugx) {%>x9<%}

String saveActionButtonName = "saveFrameworkButton";
if (debugx) {%>x10<%}
String saveActionButtonText = "Save this sheet";
if (debugx) {%>x11<%}

String frameworkIdStr = request.getParameter("frameworkId");
if (debugx) {%>x12<%}
int frameworkId = Integer.parseInt(frameworkIdStr);
if (debugx) {%>x13<%}
Framework curFramework = Framework.loadByFrameworkId(frameworkId);
if (debugx) {%>x14<%}
String previousAction = request.getParameter(saveActionButtonName);
if (debugx) {%>x15<%}
previousAction = (previousAction == null)?"":previousAction;
if (debugx) {%>x16<%}
String unknownsList = "";
if (debugx) {%>x17<%}

if ((previousAction.equalsIgnoreCase(saveActionButtonText)) && (errMsg.length() < 1))
{
    // first the framework (update existing record)
if (debugb) {%>b1<%}
    String groupIdParam = request.getParameter("groupId");
    if (groupIdParam != null)
    {
        curFramework.setGroupId(Integer.parseInt(groupIdParam));
    }
if (debugb) {%>b2<%}
    curFramework.setName(request.getParameter("name"));
if (debugb) {%>b3<%}
    curFramework.setDescription(request.getParameter("description"));
if (debugb) {%>b4<%}
    curFramework.setMaxTotalSlotsPerUser(Integer.parseInt(request.getParameter("maxTotalSlotsPerUser")));
if (debugb) {%>b5<%}
    curFramework.setMaxPendingSlotsPerUser(Integer.parseInt(request.getParameter("maxPendingSlotsPerUser")));
if (debugb) {%>b6<%}
    curFramework.setResource(request.getParameter("ssResource"));
if (debugb) {%>b7<%}
    curFramework.setLocation(request.getParameter("ssLocation"));
if (debugb) {%>b8<%}
    curFramework.setChangeAlertOwnerFlag(request.getParameter("changeAlert"));
if (debugb) {%>b9<%}
    String signupDeadlineStr = request.getParameter("signupDeadlineDate");
if (debugb) {%>b10<%}
    if ((signupDeadlineStr != null) && (signupDeadlineStr.matches("\\d+/\\d+/\\d+")))
    {
        String[] signupDeadlineStrAr = signupDeadlineStr.split("/");
        Calendar signupDeadlineCal = Calendar.getInstance();
        signupDeadlineCal.clear();
        signupDeadlineCal.set(Integer.parseInt(signupDeadlineStrAr[0]),Integer.parseInt(signupDeadlineStrAr[1])-1,Integer.parseInt(signupDeadlineStrAr[2]),23,59,59);
        curFramework.setSignupDeadline(signupDeadlineCal.getTime());
    }
    else
    {
        curFramework.setSignupDeadline(null);
    }
if (debugb) {%>b11<%}
    curFramework.save();
if (debugb) {%>b12<%}
    
    // then the access records (delete existing records, insert new ones)
    String sqlText = "DELETE FROM wms_ss_access WHERE ss_framework_id = "+frameworkIdStr;
if (debugb) {%>b13<%}
    SqlUtil.runSql(sqlText);
if (debugb) {%>b14<%}
    // ACCESS- course selection - accessByCourseIdSelection
    String[] selectedCourses = request.getParameterValues("accessByCourseIdSelection");
if (debugb) {%>b15<%}
    if (selectedCourses != null)
    {
        for (int selCourseIndex = 0; selCourseIndex < selectedCourses.length; selCourseIndex++)
        {
            Access newAccess = new Access(userPkNum, frameworkId, Integer.parseInt(selectedCourses[selCourseIndex]), Access.ACCESS_CATEGORY_COURSE);
            newAccess.saveNew();
        }
    }
    // ACCESS- user ID list - accesByUserIds
if (debugb) {%>b16<%}
    String uidList = request.getParameter("accesByUserIds");
if (debugb) {%>b17<%}
    if ((uidList != null) && (uidList.length() > 2))
    {
        String userIdList[] = uidList.split("\\s+");
        for (int ulIndex = 0; ulIndex < userIdList.length; ulIndex++)
        {
            int allowedUserPk = DataUtil.getUserPkFromUserId(userIdList[ulIndex]);
            if (allowedUserPk != 0)
            {
                Access newAccess = new Access(userPkNum, frameworkId, allowedUserPk, Access.ACCESS_CATEGORY_USER);
                newAccess.saveNew();
            }
            else
            {
                unknownsList = unknownsList + "user: " + userIdList[ulIndex] + "\n";
            }
        }
    }
    // ACCESS- course ID list - accesByCourseIdFreeform
    String cidList = request.getParameter("accesByCourseIdFreeform");
    if ((cidList != null) && (cidList.length()>5))
    {
        String[] courseIdList = cidList.split("\\s+");
        for (int clIndex = 0; clIndex < courseIdList.length; clIndex++)
        {
            int allowedCoursePk = DataUtil.getCoursePkFromCourseId(courseIdList[clIndex]);
            if (allowedCoursePk != 0)
            {
                Access newAccess = new Access(userPkNum, frameworkId, allowedCoursePk, Access.ACCESS_CATEGORY_COURSE);
                newAccess.saveNew();
            }
            else
            {
                unknownsList = unknownsList + "course: " + courseIdList[clIndex] + "\n";
            }
        }
    }
    //ACCESS-  course id substring - accessByIdSubstring
    String courseIdSubstring = request.getParameter("accessByIdSubstring");
    if ((courseIdSubstring != null) && (courseIdSubstring.length() > 2))
    {
        // get a list of all the relevant course IDs
        String[] courseIdList = DataUtil.getCourseIdListFromSubstring(courseIdSubstring);
       // create an access record for each of them
        for (int ciIndex=0; ciIndex < courseIdList.length; ciIndex++)
        {
            int allowedCoursePk = DataUtil.getCoursePkFromCourseId(courseIdList[ciIndex]);
            if (allowedCoursePk != 0)
            {
                Access newAccess = new Access(userPkNum, frameworkId, allowedCoursePk, Access.ACCESS_CATEGORY_COURSE);
                newAccess.saveNew();
            }
        }
    }
    
    // now handle the Admin records, IFF the current user is the sheet owner (if not, skip this)
    // TODO - handle admin records
    // get list of existing ones in the DB for this framework
if (debugalpha) {%>A<%}
    if (userPkNum == curFramework.getOwnerUserPk1())
    {
if (debugalpha) {%>B<%}
        AdminList existingAdmins = AdminList.loadAllAdminByFrameworkId(frameworkId);
        String adminUidList = request.getParameter("adminUserIds");
        String adminUserIdList[] = {};
        if ((adminUidList != null) && (adminUidList.length() > 2))
        {
if (debugalpha) {%>C<%}
            adminUserIdList = adminUidList.split("\\s+");
        }

        // add ones that are missing from the DB list
       // and build a hashmap for the next step
if (debugalpha) {%>D<%}
        HashMap adminUserHash = new HashMap();
        for (int i=0; i<adminUserIdList.length; i++)
        {   
if (debugalpha) {%>E<%}
            if (! (existingAdmins.hasUserId(adminUserIdList[i])))
            {
if (debugalpha) {%>F<%}
                // create a new Admin record for that user
                Admin newAdmin = new Admin(frameworkId,SqlUtil.runSqlGetIntField("SELECT pk1 FROM users WHERE user_id='"+adminUserIdList[i]+"'","pk1"),userPkNum);
                newAdmin.saveNew();
            }
if (debugalpha) {%>G<%}
            adminUserHash.put(adminUserIdList[i],new Boolean(true));
        }

if (debugalpha) {%>H<%}
        // delete ones that are missing from live (i.e. from the page) list
        Iterator existingAdminsIterator = existingAdmins.iterator();
        while (existingAdminsIterator.hasNext())
        {
if (debugalpha) {%>I<%}
            Admin a = (Admin)(existingAdminsIterator.next());
            if (! (adminUserHash.containsKey(a.getUserId())))
            {
if (debugalpha) {%>J<%}
                Admin.deleteByAdminId(a.getAdminId());
            }
        }
    }
}


String newFrameworkFlagStr = request.getParameter("isNew");
newFrameworkFlagStr = (newFrameworkFlagStr == null)?"":newFrameworkFlagStr;
boolean isNewFramework = newFrameworkFlagStr.equalsIgnoreCase("true");
        
String dateCreated = SqlUtil.dateFormatter.format(curFramework.getDateCreated());
String dateUpdated = SqlUtil.dateFormatter.format(curFramework.getDateUpdated());
int ownerUserPk1 = curFramework.getOwnerUserPk1();
int groupId = curFramework.getGroupId();
String name = curFramework.getName();
String description = curFramework.getDescription();
int maxTotalSlotsPerUser = curFramework.getMaxTotalSlotsPerUser();
int maxPendingSlotsPerUser = curFramework.getMaxPendingSlotsPerUser();
String ssResource = curFramework.getResource();
String ssLocation = curFramework.getLocation();
String changeAlert = curFramework.getChangeAlertOwnerFlag();
String signupDeadlineDate = "";
java.util.Date sdd = curFramework.getSignupDeadline();
if (sdd != null)
{
    signupDeadlineDate = HtmlCalendarTool.downToDayDateFormatter.format(sdd);
}
// need to check for error messages 
// if error message, populate init data with passed in data
// if no error messages, need to do save stuff if referer is this JSP

// need to get group list for this user
SheetGroupList groupList = SheetGroupList.loadByOwnerUserId(userPkNum);
if (course_id != null)
{
%>
<bbUI:breadcrumbBar handle="course_tools_area">
    <bbUI:breadcrumb href="<%=base_uri + "ss_admin_class.jsp?course_id="+course_id%>">Signup Sheets</bbUI:breadcrumb>
    <bbUI:breadcrumb><%=name%></bbUI:breadcrumb>
</bbUI:breadcrumbBar>
<%
}
%>

<table>
 <tr>
  <td>
<%
if (actionMessage != null)
{
    %><span style="font-size:16pt; font-weight: bold; font-family: arial, sans-serif; color: green;"><%=actionMessage%></span><%
}
%>

<%
if (unknownsList.length() > 0)
{
    %><p style="font: bold 14pt; color:red;">Access not set for these unknown entities:</p><pre style="font: bold 14pt; color:red;">
<%=unknownsList%></pre><%    
}
if (errMsg.length() > 0)
{
    %><p style="font: bold 14pt; color:red;"><%=errMsg%></p><%
    dateCreated = SqlUtil.dateFormatter.format(curFramework.getDateCreated());
    dateUpdated = SqlUtil.dateFormatter.format(curFramework.getDateUpdated());
    ownerUserPk1 = curFramework.getOwnerUserPk1();
    groupId = Integer.parseInt(request.getParameter("groupId"));
    name = request.getParameter("name");
    description = request.getParameter("description");
    maxTotalSlotsPerUser = Integer.parseInt(request.getParameter("maxTotalSlotsPerUser"));
    maxPendingSlotsPerUser = Integer.parseInt(request.getParameter("maxPendingSlotsPerUser"));
    ssResource = request.getParameter("ssResource");
    ssLocation = request.getParameter("ssLocation");
}
%>
  
<span style="float:left; font-size:16pt; font-weight:bold;">Information for the signup sheet <%=name%></span>
<%
if (course_id == null)
{
    %><span style="float:right; font-size:14pt; font-weight:bold;"><a href="<%=base_uri%>sheets/ss_admin_mod_sheet_main.jsp">Back to your sheet list</a></span>
<%
}
%>

<br clear="all">
(<i>created on <%=dateCreated%>, last updated on <%=dateUpdated%></i>)<br>

<form action="ss_admin_mod_sheet_step1.jsp" method="GET">
<input type="hidden" name="frameworkId" value="<%=frameworkIdStr%>">
  <input type="hidden" name="actionMessage" value="Saved">
<%
if (course_id != null)
{
    %> <input type="hidden" name="course_id" value="<%=course_id%>"><%
}
%>
<table>
 <tr>
  <td align="right">Name:</td>
  <td align="left"><input type="text" name="name" value="<%=name%>" SIZE="16" MAXLENGTH="64"> <i>this should make your sheet clearly identifiable - e.g. PSYC 101 Fall 2005 Lab Signups</td>
 </tr>
 <%
if (userPkNum == curFramework.getOwnerUserPk1())
{
 %>
 <tr>
  <td align="right">In group:</td>
  <td align="left">
    <select name="groupId">
<%
    Iterator groupListIterator = groupList.iterator();
    while(groupListIterator.hasNext())
    {
        wms.ss.data.SheetGroup g = (wms.ss.data.SheetGroup)groupListIterator.next();
        int listGroupId = g.getGroupId();
        String groupName = g.getName();
        %><option value="<%=listGroupId%>"<%=(groupId==listGroupId?" selected":"")%>><%=groupName%></option>
<%
    }
%>
    </select> <i>if you don't want to deal with groups you can safely leave this alone</i>
  </td>
 </tr>
 <%
}
 %>
 <tr>
  <td align="right">Brief Desription<br>(255 character max)</td>
  <td align="left"><textarea name="description" rows="4" cols="60" wrap="soft"><%=description%></textarea></td>
 </tr>
 <tr>
  <td align="right">Maximum Total<br>Signups Per User</td>
  <td align="left">
    <select name="maxTotalSlotsPerUser">
        <option value="-1"<%=(maxTotalSlotsPerUser==-1?" selected":"")%>>Unlimited</option>
<%
    for (int limitNum = 1; limitNum <= 12; limitNum++)
    {
        ;%><option value="<%=limitNum%>"<%=(maxTotalSlotsPerUser==limitNum?" selected":"")%>><%=limitNum%></option><%
    }
%>
    </select> <a style="color: red; font-size:14pt; text-decoration: underline;" onclick="alert('This is the upper limit of the total number of times a given person may sign up on this sheet. If this does not concern you, just leave it at Unlimited.');">?</a>
  </td>
 </tr>
 <tr>
  <td align="right">Alert me</td>
  <td align="left"><input type="checkbox" name="changeAlert" value="1" <%=(changeAlert.equalsIgnoreCase("Y")?" checked":"")%>> <a style="color: red; font-size:14pt; text-decoration: underline;" onclick="alert('Check this to receive email alerts whenever a user signs up for a block or removes themselves from a block.');">?</a></td>
 </tr> 
<!-- 
<tr>
  <td align="right">Resource (<i>optional</i>)</td>
  <td align="left"><input type="text" name="ssResource" value="<%=ssResource%>" SIZE="16" MAXLENGTH="64"></td>
 </tr>
 <tr>
  <td align="right">Location (<i>optional</i>)</td>
  <td align="left"><input type="text" name="ssLocation" value="<%=ssLocation%>" SIZE="16" MAXLENGTH="64"></td>
 </tr> 
-->
 <tr>
  <td align="right">Signup Deadline (<i>optional</i>)</td>
  <td align="left">
<%
String dateInputBgColor = "#bbbbbb"; 
String dayChooserInitialText = "Click to select a day";
%>
<input style="background-color:<%=dateInputBgColor%>;" id="IDsignupDeadlineDate" name="signupDeadlineDate" type="text" onfocus="if (! allowDirectDateEdit) { this.blur(); }" value="<%=signupDeadlineDate%>" SIZE="10" / > 
<input name="signupDeadlineDateButton" id="IDsignupDeadlineDateButton" type="button" value="<%=dayChooserInitialText%>"  ondblclick="allowDirectDateEdit=true; alert('You can now directly enter the date. The format is YYYY/MM/DD'); document.getElementById('IDsignupDeadlineDate').focus();" onclick="displayDatePicker('signupDeadlineDate', this, 'ymd', '/');">
<input name="signupDeadlineDateClearButton" id="IDsignupDeadlineDateClearButton" type="button" value="clear" onclick="document.getElementById('IDsignupDeadlineDate').value='';">
 <a style="color: red; font-size:14pt; text-decoration: underline;" onclick="alert('After this date users may not sign up on this sheet. Double-click the select button to enter a date manually.');">?</a></td>
 </tr> 
</table>



<h2>Course Sheet Access</h2>
<%
// get the access lists
AccessList userAccessList = AccessList.loadUserAccessByFrameworkId(frameworkId);
AccessList courseAccessList = AccessList.loadCourseAccessByFrameworkId(frameworkId);
%>
<table>
 <tr>
  <td align="center" valign="top" width="25%">
<%
    CourseDbLoader courseLoader = CourseDbLoader.Default.getInstance();
    BbList taughtCoursesList = courseLoader.loadByUserIdAndCourseMembershipRole(ctx.getUserId(),CourseMembership.Role.INSTRUCTOR);

    if (taughtCoursesList.size() < 1)
    {
%>    
You do not teach any courses.
    <%
    }
    else
    {
%>    
These are the courses you teach. Select which course(s) (multiple may be selected) that will have access to this sheet - users in those courses will be able to sign up on this sheet. YOU MUST SELECT A COURSE TO MAKE THE SHEET AVAILABLE IN THAT COURSE!<br>
    <%
        // now remove taught courses from the general access list
        %><select multiple name="accessByCourseIdSelection" size="6"><%
        for (int i = 0; i < taughtCoursesList.size(); i++)
        {
            Course c = (Course)taughtCoursesList.get(i);
            int coursePk = DataUtil.getPkFromBbId(c.getId());

        %><option value="<%=coursePk%>"<%=(courseAccessList.hasCourse(c)?" selected":"")%>><%=c.getCourseId()%></option>
    <%
            courseAccessList.removeCourse(c);
        }
    }
    %>
       </select>
  </td>
  <td align="center" valign="middle"  width="75%">

   <!--<button id="B_display_advanced_controls" onclick="var theThing = getElementById('B_display_advanced_controls'); theThing.style.display = 'none'; theThing = getElementById('advanced_controls'); theThing.style.display = 'block';">Advanced Options</button>-->
   <a style="color: red; text-decoration: underline;" id="B_display_advanced_controls" onclick="var theThing = getElementById('B_display_advanced_controls'); theThing.style.display = 'none'; theThing = getElementById('advanced_controls'); theThing.style.display = 'block';">Show Advanced Options</a>
    
<div id="advanced_controls" style="display: none; margin: 0px; border: 1px solid black;">
   <a style="float: right; color: red; text-decoration: underline;" onclick="var theThing = getElementById('B_display_advanced_controls'); theThing.style.display = 'block'; theThing = getElementById('advanced_controls'); theThing.style.display = 'none';">Hide Advanced Options</a>
<br clear="all">
<table style="margin: 0px;">
 <tr>
  <td colspan="3" align="center">
    Maximum Pending/Current Signups Per User <select name="maxPendingSlotsPerUser">
        <option value="-1"<%=(maxPendingSlotsPerUser==-1?" selected":"")%>>Unlimited</option>
<%
        for (int limitNum = 1; limitNum <= 12; limitNum++)
        {
            %><option value="<%=limitNum%>"<%=(maxPendingSlotsPerUser==limitNum?" selected":"")%>><%=limitNum%></option><%
        }
%>
    </select> <a style="color: red; font-size:14pt; text-decoration: underline;" onclick="alert('This is the limit to the number of signups a person may make in advance / in the future on this sheet.  If this does not concern you, just leave it at Unlimited.');">?</a>
  </td>
 </tr>
 <tr>
  <td align="center" width="33%"><h2>User Signup Access</h2> <a style="color: red; font-size:14pt; text-decoration: underline;" onclick="alert('These individual users have access to signup for this sheet. List users here (one per line) if you want to grant access to a specific set of users instead of or in addition to ones in a course.');">?</a></td>
  <td align="center" width="34%"><h2>Course Signup Access</h2> <a style="color: red; font-size:14pt; text-decoration: underline;" onclick="alert('People in these courses have access to signup for this sheet. List course IDs here (1 per line; IDs are like 06F-PSYC-101-01 -- [year][semester]-[subject]-[number]-[section]) if you want to grant access to a course or courses you do not teach.');">?</a></td>
  <td align="center" width="33%"><h2>Course Grab</h2> <a style="color: red; font-size:14pt; text-decoration: underline;" onclick="alert('Enter part of a course ID here, and courses that match that will be added to the course list when you save this sheet. E.g. 06F-PSYC to get all PSYC courses for the fall of 06.');">?</a></td>
 </tr>
 <tr>
  <td align="center" valign="top"><textarea name="accesByUserIds" rows="8" cols="10"><%
    // print out a list of user names based on the IDs in the userAccessList
    ConnectionManager bbConnMgr = Connect.getConnectionManager();
    java.sql.Connection conn = Connect.getConnection(bbConnMgr);
    for (int i = 0; i < userAccessList.size(); i++)
    {
        int accessUserPk = userAccessList.getPkAt(i);
        Statement sql = conn.createStatement(ResultSet.TYPE_FORWARD_ONLY, ResultSet.CONCUR_READ_ONLY);
        ResultSet res = sql.executeQuery("SELECT USER_ID FROM USERS WHERE PK1="+Integer.toString(accessUserPk));
        if (res.next())
        {
            %><%=res.getString("USER_ID")%>
<%
        }
        sql.close();
    }
    %></textarea>
  </td>
  <td align="center" valign="top"><textarea name="accesByCourseIdFreeform" rows="8" cols="18"><%
    for (int i = 0; i < courseAccessList.size(); i++)
    {
        int accessCoursePk = courseAccessList.getPkAt(i);
        Statement sql = conn.createStatement(ResultSet.TYPE_FORWARD_ONLY, ResultSet.CONCUR_READ_ONLY);
        ResultSet res = sql.executeQuery("SELECT COURSE_ID FROM COURSE_MAIN WHERE PK1="+Integer.toString(accessCoursePk));
        if (res.next())
        {
            %><%=res.getString("COURSE_ID")%>
<%
        }
        sql.close();
    }
    if(bbConnMgr != null) {
        bbConnMgr.releaseConnection(conn);
    }
    %></textarea>
  </td>
  <td align="center" valign="top"><input type="text" name="accessByIdSubstring" value="" SIZE="16" MAXLENGTH="16">
  </td>
 </tr>
</table>

<%
// limit ability to grant admin privileges to the sheet owner
if (userPkNum == curFramework.getOwnerUserPk1())
{
%>

<h2>Users with Admin Privileges</h2> <a style="color: red; font-size:14pt; text-decoration: underline;" onclick="alert('Users listed here have administrative privileges. Administrative privileges include things like being able to sign other people up for blocks, creating new time blocks, modifying the sheet description, etc - basically everything the owner (you) can do except change the sheet group and give other people admin privileges. List users here (one per line) if you want to grant Admin privileges to people other than yourself (as the owner you get them automatically, with out being listed here).');">?</a>
<%
// get the admin list
AdminList adminList = AdminList.loadAllAdminByFrameworkId(frameworkId);
%>

<table style="margin: 0px;">
 <tr>
  <td align="center" valign="top"><textarea name="adminUserIds" rows="8" cols="10"><%
    // print out a list of user names based on the IDs in the adminList
    conn = Connect.getConnection(bbConnMgr);
    for (int i = 0; i < adminList.size(); i++)
    {
        int adminUserPk = adminList.getAdminPkAt(i);
        Statement sql = conn.createStatement(ResultSet.TYPE_FORWARD_ONLY, ResultSet.CONCUR_READ_ONLY);
        ResultSet res = sql.executeQuery("SELECT USER_ID FROM USERS WHERE PK1="+Integer.toString(adminUserPk));
        if (res.next())
        {
            %><%=res.getString("USER_ID")%>
<%
        }
        sql.close();
    }
    if(bbConnMgr != null) {
        bbConnMgr.releaseConnection(conn);
    }
    %></textarea>
  </td>
 </tr>
</table>

<%
}
%>

</div>

  </td>
 </tr>
</table>
 

<br>
<center><input style="background-color:#99DD99; font-size:16pt;" type="submit" name="<%=saveActionButtonName%>" value="<%=saveActionButtonText%>"></center>
</form>

<br>

<center>
<table width="100%">
 <tr>
  <td align="left">
<% 
if (! isNewFramework)
{
%>
<form action="ss_admin_mod_sheet_step2.jsp" method="GET">
<%
if (course_id != null)
{
    %> <input type="hidden" name="course_id" value="<%=course_id%>"><%
}
%>
<input type="hidden" name="frameworkId" value="<%=frameworkIdStr%>">
<input style="font-size:14pt;" type="submit" name="blocks" value="Go on to the time blocks"> 
</form>
<%
}
%>
  </td>
  <td align="right">
  <%
String deleteText = isNewFramework?"Discard this new sheet":"Delete this sheet";
String deleteConfirmText = isNewFramework?"You are about to discard this new sheet.":"You are about to delete this sheet and all associated blocks and signups.";
%>
<form action="ss_admin_del_sheet.jsp" method="GET">
<%
if (course_id != null)
{
    %> <input type="hidden" name="course_id" value="<%=course_id%>"><%
}
%>
<input style="font:14pt;" type="hidden" name="frameworkId" value="<%=frameworkIdStr%>">
<input style="background-color:#DD9999; font-size:14pt;" type="submit" name="delete_this" value="<%=deleteText%>" onclick="return confirm('<%=deleteConfirmText%> Click OK to do so, and Cancel to abort.')">
</form>
  </td>
 </tr>
</table>
<center>



  </td>
 </tr>
</table>
<%
}
catch (Exception e)
{
    %><hr><pre><%=e.toString()%></pre><%
    StackTraceElement[] theStackTrace = e.getStackTrace();
    for (int i = 0; i < theStackTrace.length; i++)
    {
        %><%=theStackTrace[i].toString()%><br><%
    }
}
%>

</bbUI:docTemplate>
</bbData:context>

